package com.webmethods.portal.portlet.wm_bytessentcollector;

import com.webmethods.portal.PortalException;
import com.webmethods.portal.service.meta2.thing.IThingID;
import com.webmethods.portal.service.meta2.util.Atomic;
import com.webmethods.portal.service.meta2.IMetaManager;
import com.webmethods.portal.system.IURI;
import com.webmethods.portal.system.PortalSystem;
import com.webmethods.portal.bizPolicy.IContext;
import com.webmethods.portal.bizPolicy.impl.ContextFactory;
import com.webmethods.portal.framework.Handler;
import com.webmethods.portal.framework.dispatch.IDispatchPostProcessor;
import com.webmethods.portal.framework.impl.BufferedHttpServletResponse;
import com.webmethods.rtl.io.CompressedOutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * Date: Jan 5, 2005
 * Time: 6:47:10 PM
 */
public class BytesSentPostProcessor extends Handler implements IDispatchPostProcessor {

    public void postProcess(HttpServletRequest request, HttpServletResponse response) throws PortalException {
        if (response instanceof BufferedHttpServletResponse) {
            BufferedHttpServletResponse b = (BufferedHttpServletResponse)response;

            int length = 0;
            OutputStream os = null;
            try {
                os = b.getInternalOutputStream();
            } catch (IOException e) {
                return;
            }
            if (os instanceof CompressedOutputStream) {
                length = (int)((CompressedOutputStream)os).getUncompressedTotalOut();
            }
            if (os instanceof ByteArrayOutputStream) {
                length = ((ByteArrayOutputStream)os).size();
            }
            if (length == 0) {
                return;
            }

            IContext context = ContextFactory.acquireContext(request);
            IURI currentResource = context.getCurrentResource();
            IThingID currentThingID = null;
            if (currentResource instanceof IThingID) {
                currentThingID = (IThingID)currentResource;
            }

            if (currentThingID == null) {
                //create fake id
                IMetaManager iMetaManager = ((IMetaManager)PortalSystem.getMetaProvider());
                currentThingID = Atomic.createValidThingId("basic", 0, iMetaManager.getDefaultContext());
            }

            new RequestPortalEvent(currentThingID, length, context.getUserID()).raise();
        }
    }
}
