/**
 ** $Workfile: Mostpopularpages.java $
 ** Copyright (c) 2001-2004 webMethods, Inc. All Rights Reserved.
 */
package com.webmethods.portal.portlet.wm_mostpopularpages;

import com.webmethods.portal.PortalException;
import com.webmethods.portal.system.PortalSystem;
import com.webmethods.portal.service.sql.ISqlWorker;
import com.webmethods.portal.service.sql.DataManager;
import com.webmethods.portal.service.meta2.IMetaContext;
import com.webmethods.portal.service.meta2.IThingIDService;
import com.webmethods.portal.service.meta2.thing.IThingID;
import com.webmethods.portal.service.meta2.util.Atomic;
import com.webmethods.rtl.util.StringTools;

import java.util.List;
import java.util.Calendar;
import java.util.ArrayList;
import java.sql.SQLException;
import java.sql.ResultSet;
/**
 * Mostpopularpages portlet implementation.
 *
 * @version    $Revision: 1.0 $
 */
public class Mostpopularpages extends com.webmethods.portal.framework.portlet.beans.JspPortletBean {

    public final static String PROPERTY_ITEMS = "items";

    public final static String QUERY_MOST_POPULAR = "SELECT COUNT(*) AS CNT, T.IDTHING, T.IDTHINGXTYPE FROM TBLWEVENTS E INNER JOIN TBLTHING T ON THINGID_1 = T.IDTHING\n" +
            "\tWHERE E.TIMESTAMP BETWEEN ? AND ? AND T.IDTYPE = 2 AND\n" +
            "\t      E.IDTYPE = (SELECT IDTYPE FROM TBLWEVENTTYPES WHERE EVENTTYPE = 'com.webmethods.portal.event.impl.GetEvent') \n" +
            "\tGROUP BY T.IDTHING, T.IDTHINGXTYPE ORDER BY CNT DESC";

    public final static String PROPERTY_SEPARATOR = "separator";
    public List getMostPopularPages() throws PortalException {
        Calendar interval = Calendar.getInstance();
        interval.set(interval.get(Calendar.YEAR), interval.get(Calendar.MONTH), interval.get(Calendar.DAY_OF_MONTH), 0, 0, 0);
        interval.set(Calendar.MILLISECOND, 0);

        interval.add(Calendar.DAY_OF_MONTH, 1);
        Long toTime = new Long(interval.getTimeInMillis());

        interval.add(Calendar.DAY_OF_MONTH, -7);
        Long fromTime = new Long(interval.getTimeInMillis());

        ISqlWorker worker = null;
        try {

            worker = DataManager.createWorker();
            ResultSet rs = worker.executeQuery(QUERY_MOST_POPULAR, new Object[] { fromTime, toTime }, null);

            List result = new ArrayList();
            int itemsCount = getPropertyAsInt(PROPERTY_ITEMS);
            IMetaContext metaContext = getPortletThingID().getMetaContext();
            while (rs.next() && itemsCount-- > 0) {
                int dbID = rs.getInt(2);
                int xtypeID = rs.getInt(3);
                IThingID thingID = Atomic.createValidThingId(xtypeID, dbID, metaContext);
                result.add(thingID);
            }

            return result;
        }
        catch (Exception e) {
            throw new PortalException(e);
        }
        finally {
            if (worker != null) {
                worker.release();
            }
        }
    }

    /**
     * Sets the value of the 'items' property.
     *
     * @param value the value to use for the 'items' property
     */
    public void setItems(java.lang.String value) {
        setProperty(PROPERTY_ITEMS, value);
    }
    /**
     * Gets the value of the 'items' property.
     *
     * @return the value of the 'items' property
     */
    public java.lang.String getItems() throws PortalException {
        String strValue = getPropertyAsString(PROPERTY_ITEMS, null);
        if (StringTools.isEmpty(strValue)) { //null check
            return null;
        }
        return strValue;
    };
    /**
     * Sets the value of the 'separator' property.  
     *
     * @param value the value to use for the 'separator' property
     */
    public void setSeparator(java.lang.String value) {
        setProperty(PROPERTY_SEPARATOR, value);
    }
    /**
     * Gets the value of the 'separator' property.  
     *
     * @return the value of the 'separator' property
     */
    public java.lang.String getSeparator() throws PortalException {
        String strValue = getPropertyAsString(PROPERTY_SEPARATOR, null);
        if (StringTools.isEmpty(strValue)) { //null check
            return null;    
        }
        return strValue;
    };
}
