package com.webmethods.portal.portlet.wm_pagespeed;

import com.webmethods.portal.PortalException;
import com.webmethods.portal.framework.Handler;
import com.webmethods.portal.framework.dispatch.IDispatchPreProcessor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class PageSpeedProcessor extends Handler implements IDispatchPreProcessor {

    public static final String PAGE_SPEED_KEY = "page.speed.start";

    public void preProcess(HttpServletRequest request, HttpServletResponse response)
            throws PortalException {
        long millis = System.currentTimeMillis();
        request.setAttribute(PAGE_SPEED_KEY, new Long(millis));
    }

    /**
     * getTime():   Use the IWebApplication to get to the IDispatchManager;
     * whom will getComponent("Name of the handler")
     * that is this instance of this class.  Oh, that Jack built.
     *
     * @return The time when the preprocessor was triggered.(milliseconds)
     */
    public long getTime(HttpServletRequest request) throws PortalException {
        Long time = (Long) request.getAttribute(PAGE_SPEED_KEY);
        return time.longValue();
    }
}
