/**
 * 
 */
package com.webmethods.portlet.customer_orders;

/**
 * @author oleksiyo
 *
 */

import javax.portlet.PortletPreferences;

public class Customer_ordersBean extends com.webmethods.caf.faces.bean.BaseFacesPreferencesBean {

	/**
	 * List of portlet preference names
	 */
	public static final String[] PREFERENCES_NAMES = new String[] {
		"customerID", "orderID"
	};

	/**
	 * Create new preferences bean with list of preference names
	 */
	public Customer_ordersBean() {
		super(PREFERENCES_NAMES);
	}
	
	/**
	 * Call this method in order to persist
	 * Portlet preferences
	 */
	public void storePreferences() throws Exception {
		updatePreferences();
		PortletPreferences preferences = getPreferences();
		preferences.store();
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getCustomerID() throws Exception {
		return (String) getPreferenceValue("customerID", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setCustomerID(String customerID) throws Exception {
		setPreferenceValue("customerID", customerID);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getOrderID() throws Exception {
		return (String) getPreferenceValue("orderID", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setOrderID(String orderID) throws Exception {
		setPreferenceValue("orderID", orderID);
	}
}