/**
 * File Template Here 2006
 */
package com.webmethods.portlet.fileexport;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;

import javax.faces.FacesException;

import com.webmethods.caf.faces.bean.IFileExportBean;
import com.webmethods.caf.faces.bean.SimpleFileExportBean;
import com.webmethods.caf.faces.bean.portlet.PortletAction;
import com.webmethods.caf.portlet.IPortletURL;

/**
 * @author local_enorman
 *
 */
public class FileexportViewPage extends com.webmethods.caf.faces.bean.BasePageBean {

	private com.webmethods.portlet.fileexport.FileexportBean FileexportBean = null;

	public com.webmethods.portlet.fileexport.FileexportBean getFileexportBean()  {
		if (FileexportBean == null) {
		    FileexportBean = (com.webmethods.portlet.fileexport.FileexportBean)resolveExpression("#{FileexportBean}");
		}
		return FileexportBean;
	}

	/**
	 * Getter method for the control with id='portletExportCSVLink'
	 */
	public javax.faces.component.html.HtmlCommandLink getPortletExportCSVLink()  {
		return (javax.faces.component.html.HtmlCommandLink)findComponentInRoot("portletExportCSVLink");
	}

	/**
	 * Getter method for the control with id='servletExportXMLLink'
	 */
	public javax.faces.component.html.HtmlCommandLink getServletExportXMLLink()  {
		return (javax.faces.component.html.HtmlCommandLink)findComponentInRoot("servletExportXMLLink");
	}

	/**
	 * Getter method for the control with id='portletExportTextButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getPortletExportTextButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("portletExportTextButton");
	}

	/**
	 * Getter method for the control with id='portletExportImageButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getPortletExportImageButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("portletExportImageButton");
	}

	/**
	 * Getter method for the control with id='servletExportTextButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getServletExportTextButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("servletExportTextButton");
	}

	/**
	 * Getter method for the control with id='servletExportCSVButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getServletExportCSVButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("servletExportCSVButton");
	}

	/**
	 * Getter method for the control with id='servletExportImageButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getServletExportImageButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("servletExportImageButton");
	}

	/**
	 * Getter method for the control with id='portletExportXMLButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getPortletExportXMLButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("portletExportXMLButton");
	}

	/**
	 * Getter method for the control with id='servletExportXMLButton'
	 */
	public javax.faces.component.html.HtmlCommandButton getServletExportXMLButton()  {
		return (javax.faces.component.html.HtmlCommandButton)findComponentInRoot("servletExportXMLButton");
	}

	/**
	 * Action Event Handler for the control with id='portletExportTextButton' or 'servletExportTextButton'
	 */
	public String exportTextButton_action() {
		String fileContents = "Sample File Contents Here";
		String fileName = "export.txt";
		String contentType = "text/plain; charset=UTF-8";
		int contentLength = fileContents.length();
		boolean forceDownload = true; //force the user to choose what to do with the file
		
		streamFileDataToResponse(new SimpleFileExportBean(fileName, 
														contentType, 
														contentLength,
														forceDownload, 
														fileContents));
	    return OUTCOME_OK;
	}

	/**
	 * Action Event Handler for the control with id='portletExportCSVLink' or 'servletExportCSVButton'
	 */
	public String exportCSVButton_action() {
		String lineSeperator = "\r\n";
		
		//build the CSV text to export...
		StringBuffer fileContentsBuffer = new StringBuffer();
		fileContentsBuffer.append("header1,header2");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("data1,data2");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("data1a,data2a");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("data1b,data2b");
		
		String fileName = "export.csv";
		String contentType = "text/comma-separated-values; charset=UTF-8";
		int contentLength = fileContentsBuffer.length();
		boolean forceDownload = true; //force the user to choose what to do with the file
		
		//stream the file back to the user
		streamFileDataToResponse(new SimpleFileExportBean(fileName, 
														contentType, 
														contentLength,
														forceDownload, 
														fileContentsBuffer.toString()));
	    return OUTCOME_OK;
	}

	/**
	 * Action Event Handler for the control with id='portletExportImageButton' or 'servletExportImageButton' 
	 */
	@PortletAction
	public String exportImageButton_action() {
		try {
			//get the file data from a file embedded in this application
			final URL resourceURL = getFacesContext().getExternalContext().getResource("/images/export.gif");
			final URLConnection urlConnection = resourceURL.openConnection();
	
			//stream the file back to the user
			streamFileDataToResponse(new IFileExportBean() {
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#isDownloadForced()
				 */
				public boolean isDownloadForced() {
					return false; //open the image inline rather than forcing the user to choose what to do with it.
				}

				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#getExportContentLength()
				 */
				public int getExportContentLength() {
					return urlConnection.getContentLength();
				}
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#getExportContentType()
				 */
				public String getExportContentType() {
					String contentType = urlConnection.getContentType();
					if (contentType == null) {
						contentType = "image/gif";
					}
					return contentType;
				}
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#getExportFileName()
				 */
				public String getExportFileName() {
					return resourceURL.getFile();
				}
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#isExportBinary()
				 */
				public boolean isExportBinary() {
					return true;
				}
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#writeExportBytes(java.io.OutputStream)
				 */
				public void writeExportBytes(OutputStream outStream) throws IOException {
					InputStream inStream = urlConnection.getInputStream();
					byte [] buffer = new byte[1024 * 8]; //8k buffer
					int len = -1;
					while ( (len = inStream.read(buffer)) != -1 ) {
						//copy the buffer to the outstream
						outStream.write(buffer, 0, len);
					}
				}
	
				/* (non-Javadoc)
				 * @see com.webmethods.caf.faces.bean.IFileExportBean#writeExportText(java.io.PrintWriter)
				 */
				public void writeExportText(PrintWriter arg0) {
					//not used, since the export is a binary file
				}
			});
		} catch (Exception e) {
			throw new FacesException(e);
		}
		
	    return OUTCOME_OK;
	}


	/**
	 * Action Event Handler for the control with id='portletExportXMLButton' or 'servletExportXMLLink'
	 */
	public String exportXMLButton_action() {
		String lineSeperator = "\r\n";
		
		//build the CSV text to export...
		StringBuffer fileContentsBuffer = new StringBuffer();
		fileContentsBuffer.append("<?xml version='1.0' encoding='UTF-8' standalone='yes'?>");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("<data>");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("  <model attr='attr_value'>");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("    Model Body");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("  </model>");
		fileContentsBuffer.append(lineSeperator);
		fileContentsBuffer.append("</data>");
		
		String fileName = "export.xml";
		String contentType = "text/xml; charset=UTF-8";
		int contentLength = fileContentsBuffer.length();
		boolean forceDownload = false; //open in the browser.
		
		//stream the file back to the user
		streamFileDataToResponse(new SimpleFileExportBean(fileName, 
														contentType, 
														contentLength,
														forceDownload, 
														fileContentsBuffer.toString()));
	    return OUTCOME_OK;
	}

	
	public String getImageActionUrl() {
		try {
			IPortletURL actionUrl = createActionUrl();
			actionUrl.setAXSRFT(true);
			actionUrl.setTargetAction("exportImageButton_action");
			
			return "fe:" + actionUrl.toString(); //prepend fe: to make url relative to the front end url instead of this webapp context
		} catch (Exception e) {
			error(e);
			return "javscript:void(0)"; //return a do nothing url
		}
	}
	
}