/**
 ** Copyright 2005 webMethods, Inc. All Rights Reserved.
 **/
package app;

import com.webmethods.caf.faces.data.ITableContentProvider;
import com.webmethods.caf.faces.data.object.SelectableListTableContentProvider;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import javax.faces.context.FacesContext;

/**
 * JsfViewTargetInfo@37b2e4
 */
public class AsyncTablePageBean extends com.webmethods.caf.faces.bean.BasePageBean {
    protected static final int DATA_SIZE = 10000;
    protected static final Object[] DATA_ONE = { "apple", "boy", "cat", "doll" };
    protected static final Object[] DATA_TWO = { "circle", "triangle", "rectangle", "pentagon", "hexagon" };
    
    protected static List s_data = new ArrayList(DATA_SIZE);
    static {
        for (int i = 0; i < DATA_SIZE; i++)
            s_data.add(new Object[] {
                    DATA_ONE[i % DATA_ONE.length], DATA_TWO[i % DATA_TWO.length], new Integer(i),
            });
    }
    
    protected SelectableListTableContentProvider m_meaContent
        = new SelectableListTableContentProvider(new ArrayList(s_data), FacesContext.getCurrentInstance().getApplication().createValueBinding("#{row[2]}"));
    
    protected SelectableListTableContentProvider m_moreMeaContent
        = new SelectableListTableContentProvider(new ArrayList(s_data), m_meaContent.getRowIdBinding());
    
    protected SelectableListTableContentProvider m_stillMoreMeaContent
    = new SelectableListTableContentProvider(new ArrayList(s_data), m_meaContent.getRowIdBinding());
    
    protected SelectableListTableContentProvider m_littleContent
    = new SelectableListTableContentProvider(new Object[] {
            new Object[] { "one", "once upon a time", "1" },
            new Object[] { "two", "twice upon a time", "2" },
            new Object[] { "three", "thrice upon a time", "3" },
    }, "#{row[0]}") {
        protected Object newRow() {
            return new Object[3];
        }
    };
    
    public ITableContentProvider getMeaContent() {
        return m_meaContent;
    }
    
    public Collection getMeaContentSelectedIds() {
        return m_meaContent.getRowSelectedIds();
    }
    
    public ITableContentProvider getMoreMeaContent() {
        return m_moreMeaContent;
    }
    
    public Collection getMoreMeaContentSelectedIds() {
        return m_moreMeaContent.getRowSelectedIds();
    }
    
    public ITableContentProvider getStillMoreMeaContent() {
        return m_stillMoreMeaContent;
    }
    
    public Collection getStillMoreMeaContentSelectedIds() {
        return m_stillMoreMeaContent.getRowSelectedIds();
    }
    
    public ITableContentProvider getLittleContent() {
        return m_littleContent;
    }
}