/**
 ** Copyright 2005 webMethods, Inc. All Rights Reserved.
 **/
package app;

import com.webmethods.caf.faces.data.ISelectItemGroupProvider;
import com.webmethods.caf.faces.data.object.DefaultSelectItemProvider;
import com.webmethods.caf.faces.data.object.DefaultSelectItemGroupProvider;

import java.util.*;

import javax.faces.model.SelectItem;

/**
 * JsfViewTargetInfo@36ae91
 */
public class DropdownPageBean extends com.webmethods.caf.faces.bean.BasePageBean {

    
    public Map getItemsMap() {
        Map m = new HashMap();
        m.put("Item One", "Value One");
        m.put("Item Two", "Value Two");
        m.put("Item Three", "Value Three");
        return m;
    }
    
    public List getItemsList() {
        List l = new ArrayList();
        l.add(new SelectItem("Value One", "Item One"));
        l.add(new SelectItem("Value Two", "Item Two", "This is item two!", true));
        l.add(new SelectItem("Value Three", "Item Three", "This is item three!"));
        return l;
    }
    
    public ISelectItemGroupProvider getItemsGroup() {
        DefaultSelectItemGroupProvider gone = new DefaultSelectItemGroupProvider(getItemsList());
        gone.setLabel("Group One");
        
        DefaultSelectItemGroupProvider gtwo = new DefaultSelectItemGroupProvider();
        gtwo.setLabel("Group Two");
        gtwo.setDescription("This is group two!");
        gtwo.setStyle("background-color:#fcc;");
        gtwo.add(new DefaultSelectItemProvider("Item Four", "Value Four"));
        gtwo.add(new DefaultSelectItemProvider("Item Five", "Value Five", "This is item five!", true, "background-color:#cfc;", "http://stc.live.com/live/1.0.7.051/gadgets/Weather/images/32x32/11.png"));
        gtwo.add(new DefaultSelectItemProvider("Item Six", "Value Six", "This is item six!", false, "background-color:#ccf;", "http://stc.live.com/live/1.0.7.051/gadgets/Weather/images/32x32/22.png"));
        
        
        DefaultSelectItemGroupProvider g = new DefaultSelectItemGroupProvider();
        g.setLabel("Master Group");
        g.setDescription("This is the master group!");
        g.setDisabled(true);
        g.setStyle("background-color:#fcc;");
        g.add(gone);
        g.add(gtwo);
        
        return g;
    }
    
    protected String m_someValue = "Value Three";
    
    public String getSomeValue() {
        return m_someValue;
    }
    
    public void setSomeValue(String s) {
        m_someValue = s;
    }
    
    protected String[] m_someValues = new String[] { "Value Three" };
    
    public String[] getSomeValues() {
        return m_someValues;
    }
    
    public void setSomeValues(String[] s) {
        m_someValues = s;
    }
    
    public List m_someListValues = Arrays.asList(new Object[] { "Value Two" });
    
    public List getSomeListValues() {
        return m_someListValues;
    }
    
    public void setSomeListValues(List l) {
        m_someListValues = l;
    }
    
    
    
    
    
    
    
    
    /**
     * Getter method for the control with id='adv'
     */
    public com.webmethods.caf.faces.component.select.html.HtmlSelectOne getAdv()  {
    	return (com.webmethods.caf.faces.component.select.html.HtmlSelectOne)findComponentInRoot("adv");
    }

    /**
     * Getter method for the control with id='oneid'
     */
    public javax.faces.component.UISelectItem getOneid()  {
    	return (javax.faces.component.UISelectItem)findComponentInRoot("oneid");
    }

    /**
     * Getter method for the control with id='itemtwo'
     */
    public javax.faces.component.UISelectItem getItemtwo()  {
    	return (javax.faces.component.UISelectItem)findComponentInRoot("itemtwo");
    }

    /**
     * Getter method for the control with id='ithree'
     */
    public javax.faces.component.UISelectItem getIthree()  {
    	return (javax.faces.component.UISelectItem)findComponentInRoot("ithree");
    }
}
