/**
 ** Copyright 2006 webMethods, Inc. All Rights Reserved.
 **/
package app;

import com.webmethods.caf.faces.bean.BasePageBean;
import com.webmethods.caf.faces.component.util.ComponentUtils;

import javax.faces.application.FacesMessage;

/**
 * JavaTypeTargetInfo@1a9ab54
 */
public class MessagesPage extends BasePageBean {
    
    public void generateErrors() {
        generateGlobalError();
        generateControlOneError();
        generateControlTwoError();
        generateControlThreeError();
    }
    
    public void generateAll() {
        generateGlobalFatal();
        generateGlobalError();
        generateGlobalWarn();
        generateGlobalInfo();
        generateControlOneError();
        generateControlOneInfo();
        generateControlTwoError();
        generateControlTwoInfo();
        generateControlThreeError();
        generateControlThreeInfo();
    }
    
    public void generateGlobalInfo() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_INFO,
                "Info Message",
                "An informational message."
        );
        getFacesContext().addMessage(null, message);
    }
    
    public void generateGlobalWarn() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_WARN,
                "Warn Message",
                "An warning message."
        );
        getFacesContext().addMessage(null, message);
    }
    
    public void generateGlobalError() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_ERROR,
                "Error Message",
                "An error message."
        );
        getFacesContext().addMessage(null, message);
    }
    
    public void generateGlobalFatal() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_FATAL,
                "Fatal Message",
                "An fatal (to the application) error message."
        );
        getFacesContext().addMessage(null, message);
    }
    
    public void generateControlOneInfo() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_INFO,
                "Info Message (controlOne)",
                "An informational message for control one."
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlOne"), message);
    }
    
    public void generateControlOneError() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_ERROR,
                "Error Message (controlOne)",
                "An error message for control one.\nThat spans multiple\nlines.\n\n\n"
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlOne"), message);
    }
    
    public void generateControlTwoInfo() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_INFO,
                "Info Message (controlTwo)",
                "An informational message for control two."
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlTwo"), message);
    }
    
    public void generateControlTwoError() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_ERROR,
                "Error Message (controlTwo)",
                "An error message for control two.\nThat spans multiple\nlines.\n\n\n"
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlTwo"), message);
    }
    
    public void generateControlThreeInfo() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_INFO,
                "Info Message (controlThree)",
                "An informational message for control three."
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlThree"), message);
    }
    
    public void generateControlThreeError() {
        FacesMessage message = new FacesMessage(
                FacesMessage.SEVERITY_ERROR,
                "Error Message (controlThree)",
                "An error message for control three.\nThat spans multiple\nlines.\n\n\n"
        );
        getFacesContext().addMessage(ComponentUtils.createClientId(getFacesContext(), null, "controlThree"), message);
    }
}