package app;

import com.webmethods.caf.faces.bean.BasePageBean;
import com.webmethods.caf.faces.data.IContentProvider;
import com.webmethods.caf.faces.data.object.DateRange;

import java.util.Date;

import javax.faces.context.FacesContext;
import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

public class TextPageBean extends BasePageBean {
    
    protected Number simpleNumber = new Double(12345.6789d);
    protected Date simpleDate = new Date();
    protected Date advancedDate = new Date(946684800000L);
    protected String stringDate = "";
    protected DateRange simpleDateRange = new DateRange();
    protected DateRange advancedDateRange = new DateRange(2592000000L, new Date(946684800000L));
    protected SkinPropertiesProvider skinProperties = new SkinPropertiesProvider();
    
    public Date getAdvancedDate() {
        return advancedDate;
    }
    public void setAdvancedDate(Date advancedDate) {
        this.advancedDate = advancedDate;
    }
    public DateRange getAdvancedDateRange() {
        return advancedDateRange;
    }
    public void setAdvancedDateRange(DateRange advancedDateRange) {
        this.advancedDateRange = advancedDateRange;
    }
    public Date getSimpleDate() {
        return simpleDate;
    }
    public void setSimpleDate(Date simpleDate) {
        this.simpleDate = simpleDate;
    }
    public DateRange getSimpleDateRange() {
        return simpleDateRange;
    }
    public void setSimpleDateRange(DateRange simpleDateRange) {
        this.simpleDateRange = simpleDateRange;
    }
    public String getStringDate() {
        return stringDate;
    }
    public void setStringDate(String s) {
        stringDate = s;
    }
    
    public Date getReadOnlyDate() {
        return new Date();
    }
    
    public void setReadOnlyDate(Date d) {
        // no!
    }
    
    public Number getSimpleNumber() {
        return simpleNumber;
    }
    
    public void setSimpleNumber(Number n) {
        simpleNumber = n;
    }
    
    public IContentProvider getSkinProperties() {
        return skinProperties;
    }

    // classes

    /**
     * Providers that maps raw control ids to client-side element ids.
     */
    protected class SkinPropertiesProvider implements IContentProvider {

        // IContentProvider

        public Object[] getPropertyKeys() {
            return new Object[0];
        }

        public Class getType(Object propertyKey) throws PropertyNotFoundException {
            if (!(propertyKey instanceof String))
                throw new PropertyNotFoundException(propertyKey.toString());
            
            return String.class;
        }

        public Object getValue(Object propertyKey) throws EvaluationException, PropertyNotFoundException {
            if (!(propertyKey instanceof String))
                throw new PropertyNotFoundException(propertyKey.toString());
            
            FacesContext context = getFacesContext();
            return context.getApplication().getViewHandler().getResourceURL(context, "/skin/" + propertyKey);
        }

        public boolean hasProperty(Object propertyKey) {
            if (!(propertyKey instanceof String))
                return false;

            return true;
        }
    }
}
