package app;

import com.webmethods.caf.faces.bean.BasePageBean;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;

public class TotalsPageBean extends BasePageBean {
    protected List m_meaList = Arrays.asList(new Object[] {
            "one", "two", "three", "four", "five",
            "six", "seven", "eight", "nine", "ten",
            "eleven", "twelve", "thirteen", "fourteen", "fifteen",
            "sixteen", "seventeen", "eighteen", "19", "twenty",
    });
    
    public List getMeaList() {
        return m_meaList;
    }
    
    public DataModel getUnknownList() {
        return new UnknownTotalDataModel(m_meaList);
    }
    
    public List getEmptyList() {
        return new ArrayList();
    }
    
    public List getOneList() {
        return Arrays.asList(new Object[] { "one" });
    }
    
    public int getMeaFirst() {
        FacesContext context = FacesContext.getCurrentInstance();
        String s = (String) context.getExternalContext().getRequestParameterMap().get("meaFirst");
        if (s != null)
            return Integer.parseInt(s);
        return 0;
    }
    
    public int getMeaRows() {
        FacesContext context = FacesContext.getCurrentInstance();
        String s = (String) context.getExternalContext().getRequestParameterMap().get("meaRows");
        if (s != null)
            return Integer.parseInt(s);
        return 10;
    }
    
    public static class UnknownTotalDataModel extends ListDataModel {
        
        public UnknownTotalDataModel(List l) {
            super(l);
        }
        
        public int getRowCount() {
            return -1;
        }
    }

    /**
     * Getter method for the control with id='unknownTotal'
     */
    public javax.faces.component.html.HtmlDataTable getUnknownTotal()  {
    	return (javax.faces.component.html.HtmlDataTable)findComponentInRoot("unknownTotal");
    }
}