/**
 ** Copyright 2005 webMethods, Inc. All Rights Reserved.
 **/
package app;

import app.tree.cow.*;

import com.webmethods.caf.common.XMLUtil;
import com.webmethods.caf.faces.bean.BasePageBean;
import com.webmethods.caf.faces.data.tree.object.BoundChildrenTreeContentProvider;
import com.webmethods.caf.faces.data.tree.object.ListTreeContentProvider;
import com.webmethods.caf.faces.data.tree.object.NodeTreeContentProvider;
import com.webmethods.caf.faces.data.tree.object.XMLDOMNode2;

import org.w3c.dom.Document;

import java.io.InputStreamReader;
import java.util.*;

/**
 * JsfViewTargetInfo@153d79c
 */
public class TreePage extends BasePageBean {
    protected ListTreeContentProvider m_daList = new ListTreeContentProvider(Arrays.asList(new Object[] {
            new Object[] {null,"alice","apple","astros"},
            new Object[] {null,"bob","banana","brewers"},
            new Object[] {null,"carla","cantaloupe","cubs"},
            new Object[] {null,"dirk","dingleberries","dodgers"},
            new Object[] {null,"edna","eggplant","expos"},
            new Object[] {null,"frank","fruitcake","phillies"},
            new Object[] {"alice","one","pineapple","texans"},
            new Object[] {"alice","two","cranapple","stars"},
            new Object[] {"bob","three","banan-o-rama","packers"},
            new Object[] {"bob","four","banana split","badgers"},
            new Object[] {"frank","five","fruit fly","eagles"},
            new Object[] {"frank","six","fruitful","flyers"},
            new Object[] {"frank","seven","fruition","76ers"},
            new Object[] {"three","gestalt","grapes","giants"},
            new Object[] {"three","headshrinker","hawaiian punch","habs"},
    }), "#{row[1]}", "#{row[0]}", null) {
        public boolean isOpen() {
            return true;
        }
        
        public boolean getUseUnopenModel() {
            return true;
        }
        
        public Collection getUnopenIds() {
            return Collections.EMPTY_LIST;
        }
    };
    
    protected NodeTreeContentProvider m_xmlList;

    public ListTreeContentProvider getDaList() {
        return m_daList;
    }
    
    public NodeTreeContentProvider getXmlList() throws Exception {
        if (m_xmlList == null) {
            InputStreamReader in = new InputStreamReader(getFacesContext().getExternalContext().getResourceAsStream("/xml/taxonomy.xml"));
            try {
                Document doc = XMLUtil.loadDocumentFromReader(in);
                XMLDOMNode2 root = new XMLDOMNode2(doc.getDocumentElement(), "@uri");
                m_xmlList = new NodeTreeContentProvider(root);
            } finally {
                in.close();
            }
            m_xmlList.setUnopenIds(Collections.EMPTY_LIST);
        }
        return m_xmlList;
    }
    
    protected Customer[] m_customers;

    public Customer[] getCustomers() {
        if (m_customers == null) {
            m_customers = new Customer[] {
                    new Customer("customer1", "AT&T", new Order[] {
                            new Order("order1", new Date(105, 4, 1), 5000.55f, new Widget[] {
                                new Widget("widget1", "Phone Cord", 26.50f, 700),
                                new Widget("widget5", "Copper Wire - 200 ft", 49.98f, 2),
                                new Widget("widget18", "Washer - 3/4 in", 3.33f, 120),
                            }),
                            new Order("order3", new Date(105, 9, 17), 120.77f, new Widget[] {
                                new Widget("widget1", "Phone Cord", 26.50f, 300),
                                new Widget("widget44", "Deluxe Headset", 134.98f, 55),
                                new Widget("widget19", "Washer - 7/8 in", 3.33f, 120),
                            }),
                    }),
                    new Customer("customer2", "GM", new Order[] {
                            new Order("order2", new Date(105, 7, 7), 6600.57f, new Widget[] {
                                new Widget("widget145", "Engine Block", 700.50f, 30),
                                new Widget("widget38", "Spark Plugs", 33.98f, 500),
                                new Widget("widget18", "Washer - 3/4 in", 3.33f, 300),
                            }),
                            new Order("order4", new Date(106, 1, 27), 120.77f, new Widget[] {
                                new Widget("widget75", "Fan Belt", 16.50f, 300),
                                new Widget("widget89", "Motor Oil - 1 qt", 6.98f, 1200),
                                new Widget("widget19", "Washer - 15/16 in", 3.33f, 300),
                            }),
                    }),
            };
        }
        return m_customers;
    }

    public void setCustomers(Customer[] customers) {
        m_customers = customers;
    }
    
    public NodeTreeContentProvider getCustomersTree() {
        return new BoundChildrenTreeContentProvider(getCustomers(), "data",
            "#{data.customerId},#{data.orderId},#{data.widgetId}",
            "#{data.orders},#{data.widgets}");
    }
    
}
