package app.nav;

import javax.faces.context.FacesContext;

import com.webmethods.caf.faces.bean.nav.xml.XMLAppNavPage;
import com.webmethods.caf.faces.context.ContextUtils;

public class CustomersNavAppNavPage extends XMLAppNavPage {
    public static final String PARAM_CUSTOMER_ID = "customerId";
    

    public String getTitle() {
        String key = getResourceKey();
        if ("page.title.customer.details".equals(key)) {
            String bundleName = getResourceBundle();
            if (bundleName != null) {
                FacesContext ctx = ContextUtils.getFacesContext();
                
                String id = (String) ctx.getExternalContext().getRequestParameterMap().get(PARAM_CUSTOMER_ID);
                if (id == null || id.length() < 1)
                   return ContextUtils.localizeMessage(ctx, bundleName, "page.title.customer.details.no-id", null, false);
                
                return ContextUtils.localizeMessage(ctx, bundleName, key, new Object[] { id }, false);
            }
        }
        return super.getTitle();
    }

}
