package app.nav;


import java.util.Collections;

import com.webmethods.caf.faces.bean.BaseWebPageBean;
import com.webmethods.caf.faces.bean.nav.BaseAppNavBean;
import com.webmethods.caf.faces.data.tree.object.NodeTreeContentProvider;

public class CustomersNavPageBean extends BaseWebPageBean {

	/**
     * Determines if a de-serialized file is compatible with this class.
     *
     * Maintainers must change this value if and only if the new version
     * of this class is not compatible with old versions. See Sun docs
     * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
     * details. </a>
     */
    private static final long serialVersionUID = 1L;
    private static final String[][] INITIALIZE_PROPERTY_BINDINGS = new String[][] {
	};

	/**
	 * Initialize page
	 */
	public String initialize() {
		try {
		    resolveDataBinding(INITIALIZE_PROPERTY_BINDINGS, null, "initialize", true, false);

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}	
    }
    
    public BaseAppNavBean getAppNavBean() {
        BaseAppNavBean navBean = super.getAppNavBean();
        
        if (m_subnav)
            return navBean.createSubNav(navBean.getBreadcrumbs().get(1), navBean.getCurrent());
        
        return navBean;
    }
    
    public void toggleSubnav() {
        m_subnav = !m_subnav;
        m_navTree = null;
    }
    
    protected boolean m_subnav;

    public boolean isSubnav() {
        return m_subnav;
    }

    public void setSubnav(boolean subnav) {
        m_subnav = subnav;
    }
    
    protected NodeTreeContentProvider m_navTree;
    
    public NodeTreeContentProvider getNavTree() {
        if (m_navTree == null) {
            m_navTree = new NodeTreeContentProvider(getAppNavBean().getRoot());
            m_navTree.setUnopenIds(Collections.EMPTY_LIST);
        }
        return m_navTree;
    }
	
}