/**
 ** Copyright 2007 webMethods, Inc. All Rights Reserved.
 **/
package app.tree;

import java.util.List;

/**
 * MSDNLibNode for a tree with a capped size.
 */
public class CappedMSDNLibNode extends MSDNLibNode {
    protected int cap;
    
    public CappedMSDNLibNode(MSDNLib lib, MSDNLibNode parent, MSDNLibNode src, int cap) {
        super(lib, parent, src);
        this.cap = cap;
    }
    
    public CappedMSDNLibNode(MSDNLib lib, MSDNLibNode parent,
                             String id, String src, String title, String url, int cap) {
        super(lib, parent, id, src, title, url);
        this.cap = cap;
    }
    
    // INode
    
    public List getChildren() {
        if (children == null)
            children = lib.getChildren(this);
        return children;
    }
    
    // properties
    
    public int getCap() {
        return cap;
    }
    
    public void setCap(int cap) {
        this.cap = cap;
    }
}
