/**
 ** Copyright 2006 webMethods, Inc. All Rights Reserved.
 **/
package app.tree;

import com.webmethods.caf.faces.data.tree.INode;

import java.io.Serializable;
import java.util.List;

/**
 * MSDNLibNode
 */
public class MSDNLibNode implements INode, Serializable {
    protected MSDNLib lib;
    
    protected String id;
    protected MSDNLibNode parent;
    protected List children;
    
    protected String src;
    protected String title;
    protected String url;
    
    public MSDNLibNode(MSDNLib lib, MSDNLibNode parent, MSDNLibNode src) {
        this.lib = lib;
        this.parent = parent;
        this.id = src.id;
        this.src = src.src;
        this.title = src.title;
        this.url = src.url;
    }
    
    public MSDNLibNode(MSDNLib lib, MSDNLibNode parent, String id, String src, String title, String url) {
        this.lib = lib;
        this.parent = parent;
        this.id = id;
        this.src = src;
        this.title = title;
        this.url = url;
    }
    
    // INode
    
    public Object getData() {
        return this;
    }
    
    public String getId() {
        return id;
    }
    
    public INode getParent() {
        return parent;
    }
    
    public List getChildren() {
        if (children == null)
            children = lib.getChildren(this);
        return children;
    }
    
    // impl
    
    // properties

    public String getSrc() {
        return src;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }
    
    public String getUrl() {
        return url;
    }
}
