/**
 ** Copyright 2005 webMethods, Inc. All Rights Reserved.
 **/
package com.webmethods.caf.app.corecontrolstest;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;


/**
 * Adds Content-Type header.
 */
public class ContentTypeFilter implements Filter {
    protected String m_contentType = null;

    public void init(FilterConfig config) throws ServletException {
        m_contentType = config.getInitParameter("content-type");
        if (m_contentType == null || m_contentType.length() < 1)
            m_contentType = "text/html; charset=UTF-8";
    }
    
    public void destroy() {
        // nada
    }

    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        response.setContentType(m_contentType);
        chain.doFilter(request, response);
    }

}
