package com.webmethods.portlet;

import java.util.ArrayList;
import java.util.List;

import javax.faces.FacesException;
import javax.faces.application.FacesMessage;

import com.webmethods.caf.faces.data.dir.PrincipalModel;
import com.webmethods.caf.faces.data.dir.PrincipalModelFactory;
import com.webmethods.caf.faces.data.dir.PrincipalModelList;
import com.webmethods.caf.faces.data.dir.IPrincipalProvider;
import com.webmethods.portal.PortalException;
import com.webmethods.portal.service.dir.IDirConstants;
import com.webmethods.portal.system.IURI;
import com.webmethods.portal.system.PortalSystem;

public class Portal_principal_pickerPage extends com.webmethods.caf.faces.bean.BasePageBean {

	protected IPrincipalProvider fPrincipalModel = null;
	protected IPrincipalProvider fPrincipalModelPreSelected = null;
	
	protected String fPrincipalString = null;
	protected String fPrincipalStringPreSelected = null;
	
	protected IURI fPrincipalURI = null;
	protected IURI fPrincipalURIPreSelected = null;

	protected PrincipalModelList fPrincipalModelList = null;
	protected PrincipalModelList fPrincipalModelListPreSelected = null;

	protected String [] fPrincipalStrings = null;
	protected String [] fPrincipalStringsPreSelected = null;

	protected IURI [] fPrincipalURIs = null;
	protected IURI [] fPrincipalURIsPreSelected = null;
	
	/**
	 * @return the principalModel
	 */
	public IPrincipalProvider getPrincipalModel() {
		return fPrincipalModel;
	}

	/**
	 * @param principalModel the principalModel to set
	 */
	public void setPrincipalModel(IPrincipalProvider principalModel) {
		fPrincipalModel = principalModel;
	}

	/**
	 * @return the principalModelList
	 */
	public PrincipalModelList getPrincipalModelList() {
		return fPrincipalModelList;
	}

	/**
	 * @param principalModelList the principalModelList to set
	 */
	public void setPrincipalModelList(PrincipalModelList principalModelList) {
		fPrincipalModelList = principalModelList;
	}

	/**
	 * @return the principalModelListPreSelected
	 */
	public PrincipalModelList getPrincipalModelListPreSelected() {
		if (fPrincipalModelListPreSelected == null) {
			List<String> userURIList = new ArrayList<String>();
			userURIList.add(IDirConstants.ADMIN_USER_ALIAS);
			fPrincipalModelListPreSelected = new PrincipalModelList(userURIList);
		}
	
		return fPrincipalModelListPreSelected;
	}

	/**
	 * @param principalModelListPreSelected the principalModelListPreSelected to set
	 */
	public void setPrincipalModelListPreSelected(
			PrincipalModelList principalModelListPreSelected) {
		fPrincipalModelListPreSelected = principalModelListPreSelected;
	}

	/**
	 * @return the principalModelPreSelected
	 */
	public IPrincipalProvider getPrincipalModelPreSelected() {
		if (fPrincipalModelPreSelected == null) {
			//pre-select the portaladmin user
			try {
				fPrincipalModelPreSelected = PrincipalModelFactory.createPrincipalModel(IDirConstants.ADMIN_USER_ALIAS);
			} catch (PortalException e) {
				throw new FacesException(e);
			}
		}
	
		return fPrincipalModelPreSelected;
	}

	/**
	 * @param principalModelPreSelected the principalModelPreSelected to set
	 */
	public void setPrincipalModelPreSelected(
			IPrincipalProvider principalModelPreSelected) {
		fPrincipalModelPreSelected = principalModelPreSelected;
	}

	/**
	 * @return the principalString
	 */
	public String getPrincipalString() {
		return fPrincipalString;
	}

	/**
	 * @param principalString the principalString to set
	 */
	public void setPrincipalString(String principalString) {
		fPrincipalString = principalString;
	}

	/**
	 * @return the principalStringPreSelected
	 */
	public String getPrincipalStringPreSelected() {
		if (fPrincipalStringPreSelected == null) {
			try {
				IPrincipalProvider provider = PrincipalModelFactory.createPrincipalModel(IDirConstants.ADMIN_USER_ALIAS);
				if( provider != null && provider instanceof PrincipalModel ) {
					PrincipalModel model = (PrincipalModel)provider;
					fPrincipalStringPreSelected = model.getPrincipalURI().toString();
				}
			} catch (PortalException e) {
				throw new FacesException(e);
			}
		}
		return fPrincipalStringPreSelected;
	}

	/**
	 * @param principalStringPreSelected the principalStringPreSelected to set
	 */
	public void setPrincipalStringPreSelected(String principalStringPreSelected) {
		fPrincipalStringPreSelected = principalStringPreSelected;
	}

	/**
	 * @return the principalURI
	 */
	public IURI getPrincipalURI() {
		return fPrincipalURI;
	}

	/**
	 * @param principalURI the principalURI to set
	 */
	public void setPrincipalURI(IURI principalURI) {
		fPrincipalURI = principalURI;
	}

	/**
	 * @return the principalURIPreSelected
	 */
	public IURI getPrincipalURIPreSelected() {
		if (fPrincipalURIPreSelected == null) {
			try {
				IPrincipalProvider provider = PrincipalModelFactory.createPrincipalModel(IDirConstants.ADMIN_USER_ALIAS);
				if( provider != null && provider instanceof PrincipalModel ) {
					PrincipalModel model = (PrincipalModel)provider;
					fPrincipalURIPreSelected = model.getPrincipalURI();
				}
			} catch (PortalException e) {
				throw new FacesException(e);
			}
		}
		return fPrincipalURIPreSelected;
	}

	/**
	 * @param principalURIPreSelected the principalURIPreSelected to set
	 */
	public void setPrincipalURIPreSelected(IURI principalURIPreSelected) {
		fPrincipalURIPreSelected = principalURIPreSelected;
	}

	/**
	 * @return the principalStrings
	 */
	public String[] getPrincipalStrings() {
		return fPrincipalStrings;
	}

	/**
	 * @param principalStrings the principalStrings to set
	 */
	public void setPrincipalStrings(String[] principalStrings) {
		fPrincipalStrings = principalStrings;
	}

	/**
	 * @return the principalStringsPreSelected
	 */
	public String[] getPrincipalStringsPreSelected() {
		if (fPrincipalStringsPreSelected == null) {
			try {
				String principalURI = null;
				IPrincipalProvider provider = PrincipalModelFactory.createPrincipalModel(IDirConstants.ADMIN_USER_ALIAS);
				if( provider != null && provider instanceof PrincipalModel ) {
					PrincipalModel model = (PrincipalModel)provider;
					principalURI = model.getPrincipalURI().toString();
				}
				fPrincipalStringsPreSelected = new String[] { principalURI };
			} catch (PortalException e) {
				throw new FacesException(e);
			}
		}
		return fPrincipalStringsPreSelected;
	}

	/**
	 * @param principalStringsPreSelected the principalStringsPreSelected to set
	 */
	public void setPrincipalStringsPreSelected(String[] principalStringsPreSelected) {
		fPrincipalStringsPreSelected = principalStringsPreSelected;
	}

	/**
	 * @return the principalURIs
	 */
	public IURI[] getPrincipalURIs() {
		return fPrincipalURIs;
	}

	/**
	 * @param principalURIs the principalURIs to set
	 */
	public void setPrincipalURIs(IURI[] principalURIs) {
		fPrincipalURIs = principalURIs;
	}

	/**
	 * @return the principalURIsPreSelected
	 */
	public IURI[] getPrincipalURIsPreSelected() {
		if (fPrincipalURIsPreSelected == null) {
			try {
				IURI principalURI  = null;
				IPrincipalProvider provider = PrincipalModelFactory.createPrincipalModel(IDirConstants.ADMIN_USER_ALIAS);
				if( provider != null && provider instanceof PrincipalModel ) {
					PrincipalModel model = (PrincipalModel)provider;
					principalURI  = model.getPrincipalURI();
				}
				fPrincipalURIsPreSelected = new IURI [] { principalURI };
			} catch (PortalException e) {
				throw new FacesException(e);
			}
		}
		return fPrincipalURIsPreSelected;
	}

	/**
	 * @param principalURIsPreSelected the principalURIsPreSelected to set
	 */
	public void setPrincipalURIsPreSelected(IURI[] principalURIsPreSelected) {
		fPrincipalURIsPreSelected = principalURIsPreSelected;
	}

	/**
	 * Action Event Handler for the control with id='singlePrincipalModelPicker'
	 */
	public String singlePrincipalModelPicker_action() {
		error(FacesMessage.SEVERITY_INFO, "Custom Apply Action Executed", null);
	    
	    return OUTCOME_OK;
	}
	
	
}