/**
 ** Copyright 2006 webMethods, Inc. All Rights Reserved.
 **/

package com.webmethods.portlet.searchresult;

/**
 * @author local_enorman
 *
 */

import javax.portlet.PortletPreferences;

public class SearchresultBean extends com.webmethods.caf.faces.bean.BaseFacesPreferencesBean {

	private com.webmethods.portlet.Wm_corecontrolstestBean Wm_corecontrolstestBean = null;
	/**
	 * List of portlet preference names
	 */
	public static final String[] PREFERENCES_NAMES = new String[] {
		"queryString", "initialPageSize", "initialSortBy", "initialSortAscending", "columnDisplay"
	};
	/**
	 * Create new preferences bean with list of preference names
	 */
	public SearchresultBean() {
		super(PREFERENCES_NAMES);
	}
	
	/**
	 * Call this method in order to persist
	 * Portlet preferences
	 */
	public void storePreferences() throws Exception {
		updatePreferences();
		PortletPreferences preferences = getPreferences();
		preferences.store();
	}

	public com.webmethods.portlet.Wm_corecontrolstestBean getWm_corecontrolstestBean()  {
		if (Wm_corecontrolstestBean == null) {
		    Wm_corecontrolstestBean = (com.webmethods.portlet.Wm_corecontrolstestBean)resolveExpression("#{Wm_corecontrolstestBean}");
		}
		return Wm_corecontrolstestBean;
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getQueryString() throws Exception {
		return (String) getPreferenceValue("queryString", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setQueryString(String queryString) throws Exception {
		setPreferenceValue("queryString", queryString);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public Integer getInitialPageSize() throws Exception {
		return (Integer) getPreferenceValue("initialPageSize", Integer.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setInitialPageSize(Integer initialPageSize) throws Exception {
		setPreferenceValue("initialPageSize", initialPageSize);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getInitialSortBy() throws Exception {
		return (String) getPreferenceValue("initialSortBy", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setInitialSortBy(String initialSortBy) throws Exception {
		setPreferenceValue("initialSortBy", initialSortBy);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public Boolean getInitialSortAscending() throws Exception {
		return (Boolean) getPreferenceValue("initialSortAscending", Boolean.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setInitialSortAscending(Boolean initialSortAscending) throws Exception {
		setPreferenceValue("initialSortAscending", initialSortAscending);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String[] getColumnDisplay() throws Exception {
		return (String[]) getPreferenceValue("columnDisplay", String[].class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setColumnDisplay(String[] columnDisplay) throws Exception {
		setPreferenceValue("columnDisplay", columnDisplay);
	}
}