/**
 * File Template Here 2006
 */
package com.webmethods.portlet.viewlinks;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.portlet.PortletContext;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletRequest;

import com.webmethods.caf.faces.data.tree.INode;
import com.webmethods.caf.faces.data.tree.object.DefaultNode;
import com.webmethods.caf.faces.data.tree.object.NodeTreeContentProvider;

/**
 * @author local_enorman
 *
 */
public class ViewlinksViewPage extends com.webmethods.caf.faces.bean.BasePageBean {

	private com.webmethods.portlet.viewlinks.ViewlinksBean ViewlinksBean = null;
	protected NodeTreeContentProvider m_viewsList;
	
	public com.webmethods.portlet.viewlinks.ViewlinksBean getViewlinksBean()  {
		if (ViewlinksBean == null) {
		    ViewlinksBean = (com.webmethods.portlet.viewlinks.ViewlinksBean)resolveExpression("#{ViewlinksBean}");
		}
		return ViewlinksBean;
	}
	
	public NodeTreeContentProvider getAllViews() {
		if (m_viewsList == null) {
			Object request = getFacesContext().getExternalContext().getRequest();
			if (request instanceof PortletRequest) {
				PortletContext portletContext = ((PortletRequest)request).getPortletSession().getPortletContext();
				List viewsList = new ArrayList();
				addViewsToList(null, viewsList, portletContext, portletContext.getResourcePaths("/view"));

				m_viewsList = new NodeTreeContentProvider(viewsList);
				m_viewsList.setRowIdBinding(getFacesContext().getApplication().createValueBinding("#{row.id}"));
			}
		}
		return m_viewsList;
	}
	
	protected void addViewsToList(INode parent, List viewsList, PortletContext portletContext, Collection childPaths) {
	    List paths = new ArrayList(childPaths);
        Collections.sort(paths);
        
        for (Iterator it = paths.iterator(); it.hasNext();) {
			String path = (String)it.next();
			NodeData nodeData = new NodeData(path, false);
			DefaultNode node = new DefaultNode(nodeData, path);
			node.setParent(parent);
			if (path.endsWith("/")) {
				nodeData.setFolder(true);
				viewsList.add(node);
				//this is a folder path
				addViewsToList(node, node.getChildren(), portletContext, portletContext.getResourcePaths(path));
			} else {
				if (path.endsWith(".view")) {
					viewsList.add(node);
				}
			}
		}
	}
	
	public class NodeData {
		protected String m_path;
		protected boolean m_folder;

		
		public NodeData(String path, boolean folder) {
			super();
			m_path = path;
			m_folder = folder;
		}
        
        // properties
        
		/**
		 * @return Returns the folder.
		 */
		public boolean isFolder() {
			return m_folder;
		}
		/**
		 * @param folder The folder to set.
		 */
		public void setFolder(boolean folder) {
			m_folder = folder;
		}
		/**
		 * @return Returns the path.
		 */
		public String getPath() {
			return m_path;
		}
		/**
		 * @param path The path to set.
		 */
		public void setPath(String path) {
			m_path = path;
		}
		
		public String toString() {
			return getPath();
		}
	}

	/**
	 * Getter method for the control with id='tree1'
	 */
	public com.webmethods.caf.faces.component.tree.DataTree getTree1()  {
		return (com.webmethods.caf.faces.component.tree.DataTree)findComponentInRoot("tree1");
	}

	/**
	 * Getter method for the control with id='viewdata'
	 */
	public com.webmethods.caf.faces.component.table.html.HtmlTableColumn getViewdata()  {
		return (com.webmethods.caf.faces.component.table.html.HtmlTableColumn)findComponentInRoot("viewdata");
	}

	/**
	 * Getter method for the control with id='commandID'
	 */
	public javax.faces.component.html.HtmlCommandLink getCommandID()  {
		return (javax.faces.component.html.HtmlCommandLink)findComponentInRoot("commandID");
	}

	/**
	 * Action Event Handler for the control with id='commandID'
	 * @throws PortletModeException 
	 */
	public String commandID_action() throws PortletModeException {
		getImportViewControl().setValue((String)getAllViews().getValue("path"));
		
	    return null;
	}

	/**
	 * Getter method for the control with id='importViewControl'
	 */
	public com.webmethods.caf.faces.component.logic.Import getImportViewControl()  {
		return (com.webmethods.caf.faces.component.logic.Import)findComponentInRoot("importViewControl");
	}

	/**
	 * Getter method for the control with id='defaultForm'
	 */
	public javax.faces.component.html.HtmlForm getDefaultForm()  {
		return (javax.faces.component.html.HtmlForm)findComponentInRoot("defaultForm");
	}
}