/**
 * 
 */
package com.webmethods.caf;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import com.webmethods.caf.faces.data.tree.INode;
import com.webmethods.caf.faces.data.tree.object.DefaultNode;
import com.webmethods.caf.faces.data.tree.object.NodeTreeContentProvider;

/**
 * @author sergeip
 *
 */
@SuppressWarnings("unchecked")
public class MainViewPage extends com.webmethods.caf.faces.bean.BaseWebPageBean {

	private static final long serialVersionUID = 1L;

	private NodeTreeContentProvider m_viewsList;

	public NodeTreeContentProvider getAllViews() {
		if (m_viewsList == null) {
			List viewsList = new ArrayList();
			addViewsToList(null, viewsList, getFacesContext().getExternalContext().getResourcePaths("/view"));

			m_viewsList = new NodeTreeContentProvider(viewsList);
			m_viewsList.setRowIdBinding(getFacesContext().getApplication().createValueBinding("#{row.id}"));
		}
		return m_viewsList;
	}
	
	protected void addViewsToList(INode parent, List viewsList, Collection childPaths) {
	    List paths = new ArrayList(childPaths);
        Collections.sort(paths);
        
        for (Iterator it = paths.iterator(); it.hasNext();) {
			String path = (String)it.next();
			NodeData nodeData = new NodeData(path, false);
			DefaultNode node = new DefaultNode(nodeData, path);
			node.setParent(parent);
			if (path.endsWith("/")) {
				nodeData.setFolder(true);
				viewsList.add(node);
				//this is a folder path
				addViewsToList(node, node.getChildren(), getFacesContext().getExternalContext().getResourcePaths(path));
			} else {
				if (path.endsWith(".view")) {
					viewsList.add(node);
				}
			}
		}
	}
	
	protected class NodeData {
		protected String m_path;
		protected boolean m_folder;

		
		public NodeData(String path, boolean folder) {
			super();
			m_path = path;
			m_folder = folder;
		}
        
        // properties
        
		/**
		 * @return Returns the folder.
		 */
		public boolean isFolder() {
			return m_folder;
		}
		/**
		 * @param folder The folder to set.
		 */
		public void setFolder(boolean folder) {
			m_folder = folder;
		}
		/**
		 * @return Returns the path.
		 */
		public String getPath() {
			return m_path;
		}
		/**
		 * @param path The path to set.
		 */
		public void setPath(String path) {
			m_path = path;
		}
		
		public String toString() {
			return getPath();
		}
	}

	/**
	 * Getter method for the control with id='commandID'
	 */
	public javax.faces.component.html.HtmlCommandLink getCommandID()  {
		return (javax.faces.component.html.HtmlCommandLink)findComponentInRoot("commandID");
	}

	/**
	 * Getter method for the control with id='tree1'
	 */
	public com.webmethods.caf.faces.component.tree.DataTree getTree1()  {
		return (com.webmethods.caf.faces.component.tree.DataTree)findComponentInRoot("tree1");
	}

	/**
	 * Getter method for the control with id='defaultForm'
	 */
	public javax.faces.component.html.HtmlForm getDefaultForm()  {
		return (javax.faces.component.html.HtmlForm)findComponentInRoot("defaultForm");
	}

	/**
	 * Getter method for the control with id='importViewControl'
	 */
	public com.webmethods.caf.faces.component.logic.Import getImportViewControl()  {
		return (com.webmethods.caf.faces.component.logic.Import)findComponentInRoot("importViewControl");
	}

	/**
	 * Action Event Handler for the control with id='commandID'
	 */
	public String commandID_action() {
	    getImportViewControl().setValue((String)getAllViews().getValue("path"));
	    
	    return null;
	}
	
}