package com.webmethods.caf;

import com.webmethods.caf.faces.data.object.PageableTableContentProvider;

public class PageableTablePage extends com.webmethods.caf.faces.bean.BaseWebPageBean {

	private static final long serialVersionUID = 1L;

	private com.webmethods.service.SamplePagingService samplePagingService = null;
	private PageableTableContentProvider pageProvider = null;
	private int tablePageSize = 10;
	
	private static final String[][] PAGEPROVIDER_INIT_BINDINGS = new String[][] {
		{"#{pageProvider.rowVariable}", "row"},
		{"#{pageProvider.rowIdBinding}", "#{row.id}"},
		{"#{pageProvider.refreshPageBinding}", "#{PageableTablePage.refreshPageData}"},
	};
	private static final String[][] REFRESHPAGEDATA_PROPERTY_BINDINGS = new String[][] {
		{"#{PageableTablePage.samplePagingService.start}", "#{PageableTablePage.pageProvider.pageRowIndex}"},
		{"#{PageableTablePage.samplePagingService.refresh}", null},
		{"#{PageableTablePage.pageProvider.list}", "#{PageableTablePage.samplePagingService.data}"},
	};
	private static final String[][] RESET_PROPERTY_BINDINGS = new String[][] {
		{"#{PageableTablePage.samplePagingService.numberOfCalls}", "0"},
		{"#{PageableTablePage.pageProvider.refresh}", null},
	};
	private static final String[][] SAMPLEPAGINGSERVICE_PROPERTY_BINDINGS = new String[][] {
		{"#{samplePagingService.autoRefresh}", "false"},
	};

	private static final String[][] PAGEPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{pageProvider.rowType}", "com.webmethods.service.SampleItem"},
	};

	public com.webmethods.service.SamplePagingService getSamplePagingService()  {
		if (samplePagingService == null) {
		    samplePagingService = new com.webmethods.service.SamplePagingService();
		}
	
	    resolveDataBinding(SAMPLEPAGINGSERVICE_PROPERTY_BINDINGS, samplePagingService, "samplePagingService", true, false);
		return samplePagingService;
	}

	public PageableTableContentProvider getPageProvider()  {
		if (pageProvider == null) {
		    pageProvider = new PageableTableContentProvider();
		    // initialization
		    resolveDataBinding(PAGEPROVIDER_INIT_BINDINGS, pageProvider, "pageProvider", true, false);
		}
	
		return pageProvider;
	}
	
	public void refreshPageData() {
		resolveDataBinding(REFRESHPAGEDATA_PROPERTY_BINDINGS, this, "refreshPageData", true, false);
	}
	
	public void reset() {
		resolveDataBinding(RESET_PROPERTY_BINDINGS, this, "reset", true, false);
	}

	public int getTablePageSize()  {
		return tablePageSize;
	}

	public void setTablePageSize(int tablePageSize)  {
		this.tablePageSize = tablePageSize;
	}
	
}