package com.webmethods.service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class SampleData {
	
	private List<SampleItem> itemList;
	private SampleItem[] itemArray;
	
	public SampleItem[] getItemArray() {
		if (itemArray == null) {
			itemArray = generateItems(5, 1, true);
		}
		return itemArray;
	}

	public void setItemArray(SampleItem[] itemArray) {
		this.itemArray = itemArray;
	}

	public List<SampleItem> getItemList() {
		if (itemList == null) {
			itemList = new ArrayList<SampleItem>(Arrays.asList(getItemArray()));
		}
		return itemList;
	}

	public void setItemList(List<SampleItem> itemList) {
		this.itemList = itemList;
	}
	
	public static SampleItem[] generateItems(int total, int startingIndex, boolean generateChildren) {
		SampleItem[] result = new SampleItem[total];
		for (int i = 0; i < total; i++) {
			int id = startingIndex + i;
			result[i] = new SampleItem(id, "Item #" + id, "Description #" + id);
			if (generateChildren) {
				result[i].setChildren(generateItems(id, 1, false));
			}
		}
		return result;
	}
	
}
