package com.webmethods.service;

import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

import com.webmethods.caf.faces.data.ContentProviderException;
import com.webmethods.caf.faces.data.IRefreshableContentProvider;

/**
 * Sample data service
 * Returns output array of SampeItem's populated based on input parameters
 *  
 * @author sergeip
 *
 */
public class SampleDataService implements IRefreshableContentProvider {

	private boolean autoRefresh = true;
	private boolean needRefresh = true;

	private com.webmethods.service.SampleItem[] output;
	private Inputs inputs = new Inputs();
	
	public class Inputs {
		private int itemCount = 0;
		private String itemName = "item";
		private String itemDescription = "description";
		private boolean populateChildren = false;
		
		public String getItemDescription() {
			return itemDescription;
		}
		public void setItemDescription(String itemDescription) {
			this.itemDescription = itemDescription;
		}
		public String getItemName() {
			return itemName;
		}
		public void setItemName(String itemName) {
			this.itemName = itemName;
		}
		public int getItemCount() {
			return itemCount;
		}
		public void setItemCount(int itemNumber) {
			this.itemCount = itemNumber;
		}
		public boolean isPopulateChildren() {
			return populateChildren;
		}
		public void setPopulateChildren(boolean populateChildren) {
			this.populateChildren = populateChildren;
		}
	}

	public Inputs getInputs() {
		return inputs;
	}

	public com.webmethods.service.SampleItem[] getOutput() {
		return output;
	}

	public boolean getNeedRefresh() {
		return needRefresh;
	}

	public boolean isAutoRefresh() {
		return autoRefresh;
	}

	/**
	 * Generate the date based on inputs
	 */
	public void refresh() throws ContentProviderException {
		output = generateItems(inputs.getItemCount(), inputs.getItemName(), inputs.getItemDescription(), inputs.isPopulateChildren());
 	}
	
	private SampleItem[] generateItems(int count, String itemName, String itemDescription, boolean generateChildren) {
		SampleItem[]output = new SampleItem[count];
		 
		// nothing
		for (int i = 0; i < count; i++) {
			output[i] = new SampleItem(
					i, 
					itemName + " " + i, 
					itemDescription + " " + i);
			if (generateChildren) {
				output[i].setChildren(generateItems(i, "Child " + itemName, "Child " + itemDescription, false));
			}
		}		
		return output;
	}

	public void setAutoRefresh(boolean arg0) throws ContentProviderException {
		autoRefresh = arg0;
	}

	public void setNeedRefresh(boolean arg0) {
		this.needRefresh = arg0;
	}

	public boolean supportsAutoRefresh() {
		return true;
	}

	// no extra dynamic properties
	
	public Object[] getPropertyKeys() {
		return new Object[0];
	}

	public Class getType(Object arg0) throws PropertyNotFoundException {
		return null;
	}

	public Object getValue(Object arg0) throws EvaluationException,
			PropertyNotFoundException {
		return null;
	}

	public boolean hasProperty(Object arg0) {
		return false;
	}

}
