package com.webmethods.service;

import java.util.Date;

import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

import com.webmethods.caf.faces.data.ContentProviderException;
import com.webmethods.caf.faces.data.IRefreshableContentProvider;

/**
 * Echo service implementation
 * Returns input array and updates description 
 *  
 * @author sergeip
 *
 */
public class SampleEchoService implements IRefreshableContentProvider {

	private com.webmethods.service.SampleItem[] input;
	private com.webmethods.service.SampleItem[] output;
	private boolean needRefresh = true;
	
	public com.webmethods.service.SampleItem[] getInput() {
		return input;
	}

	public void setInput(com.webmethods.service.SampleItem[] input) {
		this.input = input;
	}

	public com.webmethods.service.SampleItem[] getOutput() {
		return output;
	}

	public boolean getNeedRefresh() {
		return needRefresh;
	}

	public boolean isAutoRefresh() {
		return true;
	}

	public void refresh() throws ContentProviderException {
		if (input == null) {
			output = null;
			return;
		}
		
		output = new SampleItem[input.length];
		int i = 0; 
		// nothing
		for (SampleItem item: input) {
			output[i++] = new SampleItem(
					item.getId(), 
					item.getName(), 
					item.getDescription() + " @ " + new Date());
		}
	}

	public void setAutoRefresh(boolean arg0) throws ContentProviderException {
	}

	public void setNeedRefresh(boolean arg0) {
		this.needRefresh = arg0;
	}

	public boolean supportsAutoRefresh() {
		return true;
	}

	// no extra properties
	
	public Object[] getPropertyKeys() {
		return new Object[0];
	}

	public Class getType(Object arg0) throws PropertyNotFoundException {
		return null;
	}

	public Object getValue(Object arg0) throws EvaluationException,
			PropertyNotFoundException {
		return null;
	}

	public boolean hasProperty(Object arg0) {
		return false;
	}

}
