package com.webmethods.service;

import java.util.Arrays;
import java.util.List;

import javax.faces.el.EvaluationException;
import javax.faces.el.PropertyNotFoundException;

import com.webmethods.caf.faces.data.ContentProviderException;
import com.webmethods.caf.faces.data.IRefreshableContentProvider;

public class SamplePagingService implements IRefreshableContentProvider {

	// biz data
	private int start = 0;
	private int size = 10;
	private List<SampleItem> result;
	private int totalRecords = 25;

	// IRefreshableContentProvider support
	private boolean autoRefresh = true;
	private boolean needRefresh = true;
	
	// for testing
	private int numberOfCalls = 0;

	public SamplePagingService() {
	}

	public SamplePagingService(int totalRecords) {
		setTotalRecords(totalRecords);
	}
	
	public int getStart()  {
		return start;
	}

	public void setStart(int start)  {
		setNeedRefresh(this.start != start);
		this.start = start;
	}

	public int getSize()  {
		return size;
	}

	public void setSize(int size)  {
		setNeedRefresh(this.size != size);
		this.size = size;
	};
	
	/**
	 * Return single page rows
	 * @return
	 */
	public List<SampleItem> getData() {
		return result;
	}

	public void refresh() throws ContentProviderException {
		if (getStart() < getTotalRecords()) {
			int total = (getStart() + getSize() < getTotalRecords()) ? getSize() :  (getTotalRecords() - getStart()); 
			result = Arrays.asList(SampleData.generateItems(total, getStart() + 1, false));
		} else {
			result = null;
		}
		numberOfCalls++;
	}

	public int getNumberOfCalls() {
		return numberOfCalls;
	}

	public void setNumberOfCalls(int numberOfCalls) {
		this.numberOfCalls = numberOfCalls;
	}

	public int getTotalRecords() {
		return totalRecords;
	}

	public void setTotalRecords(int totalRecords) {
		this.totalRecords = totalRecords;
	}

	public boolean supportsAutoRefresh() {
		return true;
	}

	public void setAutoRefresh(boolean autorefresh) throws ContentProviderException {
		this.autoRefresh = autorefresh;
	}

	public boolean isAutoRefresh() {
		return autoRefresh;
	}

	public boolean getNeedRefresh() {
		return needRefresh;
	}

	public void setNeedRefresh(boolean needRefresh) {
		this.needRefresh = needRefresh;
	}

	public Object[] getPropertyKeys() {
		return new Object[0];
	}

	public boolean hasProperty(Object propertyKey) {
		return false;
	}

	public Object getValue(Object propertyKey) throws EvaluationException, PropertyNotFoundException {
		return null;
	}

	@SuppressWarnings("unchecked")
	public Class getType(Object propertyKey) throws PropertyNotFoundException {
		return null;
	} 

}
