/**
 * 
 */
package com.webmethods.portlet.controls;

/**
 * @author oleksiyo
 *
 */

import javax.portlet.PortletPreferences;

public class ControlsBean extends com.webmethods.caf.faces.bean.BaseFacesPreferencesBean {

	private com.webmethods.portlet.Wm_portlet_linksBean Wm_portlet_linksBean = null;
	/**
	 * List of portlet preference names
	 */
	public static final String[] PREFERENCES_NAMES = new String[] {
		"textInputValue", "dropDownInputValue", "checkboxGroupValue", "radioGroupValue", "listboxInputValue"
	};
	/**
	 * Create new preferences bean with list of preference names
	 */
	public ControlsBean() {
		super(PREFERENCES_NAMES);
	}
	
	/**
	 * Call this method in order to persist
	 * Portlet preferences
	 */
	public void storePreferences() throws Exception {
		updatePreferences();
		PortletPreferences preferences = getPreferences();
		preferences.store();
	}

	public com.webmethods.portlet.Wm_portlet_linksBean getWm_portlet_linksBean()  {
		if (Wm_portlet_linksBean == null) {
		    Wm_portlet_linksBean = (com.webmethods.portlet.Wm_portlet_linksBean)resolveExpression("#{Wm_portlet_linksBean}");
		}
		return Wm_portlet_linksBean;
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getTextInputValue() throws Exception {
		return (String) getPreferenceValue("textInputValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setTextInputValue(String textInputValue) throws Exception {
		setPreferenceValue("textInputValue", textInputValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getDropDownInputValue() throws Exception {
		return (String) getPreferenceValue("dropDownInputValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setDropDownInputValue(String dropDownInputValue) throws Exception {
		setPreferenceValue("dropDownInputValue", dropDownInputValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String[] getCheckboxGroupValue() throws Exception {
		return (String[]) getPreferenceValue("checkboxGroupValue", String[].class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setCheckboxGroupValue(String[] checkboxGroupValue) throws Exception {
		setPreferenceValue("checkboxGroupValue", checkboxGroupValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String[] getListboxInputValue() throws Exception {
		return (String[]) getPreferenceValue("listboxInputValue", String[].class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setListboxInputValue(String[] listboxInputValue) throws Exception {
		setPreferenceValue("listboxInputValue", listboxInputValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getRadioGroupValue() throws Exception {
		return (String) getPreferenceValue("radioGroupValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setRadioGroupValue(String radioGroupValue) throws Exception {
		setPreferenceValue("radioGroupValue", radioGroupValue);
	}
}