/**
 * 
 */
package com.webmethods.portlet.wire_config;

/**
 * @author mitchw
 *
 */

import javax.portlet.PortletPreferences;

public class Wire_configBean extends com.webmethods.caf.faces.bean.BaseFacesPreferencesBean {

	/**
	 * List of portlet preference names
	 */
	public static final String[] PREFERENCES_NAMES = new String[] {
		"HostValue", "PortValue", "UseSSLValue", "ProtocolValue", "AuthPort", "AuthHost", "AuthUseSSL", "AuthProtocol", "InboxURL", "WfServerHost", "WfServerPort", "DcsPort", "DcsHost", "DcsUseSSL", "DcsProtocol"
	};

	/**
	 * Create new preferences bean with list of preference names
	 */
	public Wire_configBean() {
		super(PREFERENCES_NAMES);
	}
	
	/**
	 * Call this method in order to persist
	 * Portlet preferences
	 */
	public void storePreferences() throws Exception {
		updatePreferences();
		PortletPreferences preferences = getPreferences();
		preferences.store();
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getHostValue() throws Exception {
		return (String) getPreferenceValue("HostValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setHostValue(String hostValue) throws Exception {
		setPreferenceValue("HostValue", hostValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getPortValue() throws Exception {
		return (String) getPreferenceValue("PortValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setPortValue(String portValue) throws Exception {
		setPreferenceValue("PortValue", portValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getProtocolValue() throws Exception {
		return (String) getPreferenceValue("ProtocolValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setProtocolValue(String protocolValue) throws Exception {
		setPreferenceValue("ProtocolValue", protocolValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getUseSSLValue() throws Exception {
		return (String) getPreferenceValue("UseSSLValue", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setUseSSLValue(String useSSLValue) throws Exception {
		setPreferenceValue("UseSSLValue", useSSLValue);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getAuthHost() throws Exception {
		return (String) getPreferenceValue("AuthHost", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setAuthHost(String authHost) throws Exception {
		setPreferenceValue("AuthHost", authHost);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getAuthUseSSL() throws Exception {
		return (String) getPreferenceValue("AuthUseSSL", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setAuthUseSSL(String authUseSSL) throws Exception {
		setPreferenceValue("AuthUseSSL", authUseSSL);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getAuthPort() throws Exception {
		return (String) getPreferenceValue("AuthPort", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setAuthPort(String authPort) throws Exception {
		setPreferenceValue("AuthPort", authPort);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getAuthProtocol() throws Exception {
		return (String) getPreferenceValue("AuthProtocol", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setAuthProtocol(String authProtocol) throws Exception {
		setPreferenceValue("AuthProtocol", authProtocol);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getInboxURL() throws Exception {
		return (String) getPreferenceValue("InboxURL", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setInboxURL(String inboxURL) throws Exception {
		setPreferenceValue("InboxURL", inboxURL);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getWfServerHost() throws Exception {
		return (String) getPreferenceValue("WfServerHost", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setWfServerHost(String wfServerHost) throws Exception {
		setPreferenceValue("WfServerHost", wfServerHost);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getWfServerPort() throws Exception {
		return (String) getPreferenceValue("WfServerPort", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setWfServerPort(String wfServerPort) throws Exception {
		setPreferenceValue("WfServerPort", wfServerPort);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getDcsPort() throws Exception {
		return (String) getPreferenceValue("DcsPort", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setDcsPort(String dcsPort) throws Exception {
		setPreferenceValue("DcsPort", dcsPort);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getDcsHost() throws Exception {
		return (String) getPreferenceValue("DcsHost", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setDcsHost(String dcsHost) throws Exception {
		setPreferenceValue("DcsHost", dcsHost);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getDcsUseSSL() throws Exception {
		return (String) getPreferenceValue("DcsUseSSL", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setDcsUseSSL(String dcsUseSSL) throws Exception {
		setPreferenceValue("DcsUseSSL", dcsUseSSL);
	}

	/**
	 * The algorithm for this 'smart' preference getter is:
	 * 1) Check the Request Map (skip this step if it isn't a 'smart' preference)
	 * 2) Check the Member variable
	 * 3) Fall back to the PortletPreferences
	 */
	public String getDcsProtocol() throws Exception {
		return (String) getPreferenceValue("DcsProtocol", String.class);
	}

	/**
	 * Invoke {@link #storePreferences} to persist these changes
	 */
	public void setDcsProtocol(String dcsProtocol) throws Exception {
		setPreferenceValue("DcsProtocol", dcsProtocol);
	}
}