package com.webmethods.caf;

import java.text.DateFormat;
import java.util.Date;
import java.util.Locale;

import com.webmethods.caf.common.StringTools;
import com.wm.g11n.util.NumberFormatContext;
import com.wm.g11n.util.iContext;


public class ConverterSamplescustomhandlerView extends com.webmethods.caf.faces.bean.BasePageBean {

	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	protected String m_sDate = ( new Date()).toString();
	protected String m_sNumber = "12345678";
	protected String m_sCurrency = "1000.34";
	public String returnOK() {
		return "Ok";
	}
	
	public String getCurrentLocale() {
		Locale loc = getLocale();
		if( loc == null )
			return "MWS Default";
		return loc.getDisplayLanguage()+" - "+ loc.getDisplayCountry();
	}
	
	public String getDateString() {
		return m_sDate;
	}
	public void setDateString(String sValue ) {
		m_sDate = sValue;
	}
	public String getNumberString() {
		return m_sNumber;
	}
	public void setNumberString(String sValue) {
		m_sNumber = sValue;
	}
	public String getCurrencyString() {
		return m_sCurrency;
	}
	public void setCurrencyString(String sValue) {
		m_sCurrency = sValue;
	}

	/**
	 * Converter Class for the control with id='dateInput'
	 */
	 public javax.faces.convert.Converter getDateInput_converter()
	 {
	    return new javax.faces.convert.Converter()
	    {
	       /**
	        * Convert the input Object into a string.
	        */
	        public String getAsString( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.Object value)
	        {
	            // TODO: Convert the Object to a String here.
	        	if( value == null || !(value instanceof String))
	        		return "0";
	        	
	        	Date dValue = new Date( (String)value );
	        	iContext g11nContext = getG11NContext();
	        	return g11nContext.getDateFormatDateTimeInstance( DateFormat.SHORT ).format( dValue );
	        }
	       /**
	        * Convert the input String into an Object.
	        */
	        public Object getAsObject( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.String value)
	        {
	            // TODO: Convert the String to an Object here.
	        	Date dValue = new Date();
	        	if( StringTools.isEmpty( value ))
	        		return dValue.toString();
	        	iContext g11nContext = getG11NContext();
	        	try {
	        		dValue = g11nContext.getDateFormatDateTimeInstance( DateFormat.SHORT ).parse( value );
	        	}
	        	catch( Exception ex ) {
	        		return dValue.toString();
	        	}	        		
	            return dValue.toString();
	        }
	    };
	 }

	/**
	 * Converter Class for the control with id='numberInput'
	 */
	 public javax.faces.convert.Converter getNumberInput_converter()
	 {
	    return new javax.faces.convert.Converter()
	    {
	       /**
	        * Convert the input Object into a string.
	        */
	        public String getAsString( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.Object value)
	        {
	            // TODO: Convert the Object to a String here.
	        	if( value == null || !(value instanceof String))
	        		return "0";
	        	
	        	Double dValue = new Double( (String)value );
	        	iContext g11nContext = getG11NContext();
	        	return g11nContext.getNumberFormatInstance( NumberFormatContext.NUMBERSTYLE ).format( dValue );
	        }
	       /**
	        * Convert the input String into an Object.
	        */
	        public Object getAsObject( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.String value)
	        {
	            // TODO: Convert the Object to a String here.
	        	Double dValue = new Double(0);
	        	if( StringTools.isEmpty( value ))
	        		return "0";
	        	iContext g11nContext = getG11NContext();
	        	try {
	        		Number nValue = g11nContext.getNumberFormatInstance( NumberFormatContext.NUMBERSTYLE ).parse( value );
	        		dValue = nValue.doubleValue();
	        	}
	        	catch( Exception ex ) {
	        		return "0";
	        	}	        		
	            return dValue.toString();
	        }
	    };
	 }

	/**
	 * Converter Class for the control with id='currencyInput'
	 */
	 public javax.faces.convert.Converter getCurrencyInput_converter()
	 {
	    return new javax.faces.convert.Converter()
	    {
	       /**
	        * Convert the input Object into a string.
	        */
	        public String getAsString( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.Object value)
	        {
	            // TODO: Convert the Object to a String here.
	        	if( value == null || !(value instanceof String))
	        		return "0";
	        	
	        	Double dValue = new Double( (String)value );
	        	iContext g11nContext = getG11NContext();
	        	return g11nContext.getNumberFormatInstance( NumberFormatContext.CURRENCYSTYLE ).format( dValue );
	        }
	       /**
	        * Convert the input String into an Object.
	        */
	        public Object getAsObject( javax.faces.context.FacesContext context, javax.faces.component.UIComponent component, java.lang.String value)
	        {
	            // TODO: Convert the Object to a String here.
	        	Double dValue = new Double(0);
	        	if( StringTools.isEmpty( value ))
	        		return "0";
	        	iContext g11nContext = getG11NContext();
	        	try {
	        		Number nValue = g11nContext.getNumberFormatInstance( NumberFormatContext.CURRENCYSTYLE ).parse( value );
	        		dValue = nValue.doubleValue();
	        	}
	        	catch( Exception ex ) {
	        		return "0";
	        	}	        		
	            return dValue.toString();
	        }
	    };
	 }
	 
	 protected iContext getG11NContext() {
		 return new iContext( getLocale());
	 }
}