/**
 * 
 */
package com.webmethods.portlet.check_box_group;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.faces.model.SelectItem;

import com.webmethods.caf.common.StringTools;
import com.webmethods.caf.faces.data.object.ListTableContentProvider;


/**
 * @author mitchw
 *
 */
public class Check_box_groupViewPageBean extends com.webmethods.caf.faces.bean.BasePageBean 
{
	protected String[] m_sSelectionMap = null;
	protected String[] m_sSelectionList = null;
	protected String[] m_sSelectionArray = null;
	
	protected Object[] m_DataSource = { new String[]{"Bob",  "1", "BackOrder" },
										new String[]{"Jack", "2", "BackOrder" },
										new String[]{"Jill", "3", "BackOrder" },
										new String[]{"Sue",  "4", "BackOrder" }};

	protected Object[] m_EmptySource = { new String[]{"Select an item",  "", "" }};
	
	protected ListTableContentProvider m_listContentMap = new ListTableContentProvider( Arrays.asList( m_EmptySource));
	protected ListTableContentProvider m_listContentList = new ListTableContentProvider( Arrays.asList( m_EmptySource));
	protected ListTableContentProvider m_listContentArray = new ListTableContentProvider( Arrays.asList( m_EmptySource));

	/**
	 * Data Sources for the list selections.
	 * List -
	 * Map - 
	 * Array -
	 */
	 
	 /**
	  * Create an index key to the data that can be displayed in a list.
	  * 
	  */
	 public List getSourceList()
	 {
		 List aList = new ArrayList();
		 for( int i=0; i< m_DataSource.length; i++ )
		 {
			 // see javax.faces.model.SelectItems for more details
			 aList.add( new SelectItem( String.valueOf(i), ((String[])m_DataSource[i])[0] ));
		 }
		 return aList;
	 }

	 /**
	  * Create an index key to the data that can be displayed in a list.
	  */
	 public Map getSourceMap()
	 {
		 Map map = new HashMap();
		 
		 for( int i=0; i< m_DataSource.length; i++ )
		 {
			 map.put( ((String[])m_DataSource[i])[0], String.valueOf(i));
		 }
		 return map;
	 }

	 /**
	  * Create an index key to the data that can be displayed in a list.
	  */
	 public Object[] getSourceArray()
	 {
		 ArrayList aList = new ArrayList();
		 for( int i=0; i< m_DataSource.length; i++ )
		 {
			 // see javax.faces.model.SelectItems for more details
			 aList.add( new SelectItem(  String.valueOf(i), ((String[])m_DataSource[i])[0] ));
		 }
		 return aList.toArray();
	 }
	 
	 public String[] getSelectionMap()
	 {
		 return m_sSelectionMap;
	 }

	 public void setSelectionMap( String[] sSelection )
	 {
		 m_sSelectionMap = sSelection;
		 // Use a generic method to check the selection 
		 // and set the content for the provider.
		 m_listContentMap = setSingleSelect( m_sSelectionMap );
	 }

	 public String[] getSelectionList()
	 {
		 return m_sSelectionList;
	 }

	 public void setSelectionList( String[] sSelection )
	 {
		 m_sSelectionList = sSelection;
		 // Use a generic method to check the selection 
		 // and set the content for the provider.
		 m_listContentList = setSingleSelect( m_sSelectionList );
	 }

	 public String[] getSelectionArray()
	 {
		 return m_sSelectionArray;
	 }
	 
	 public void setSelectionArray( String[] sSelection )
	 {
		 m_sSelectionArray = sSelection;
		 // Use a generic method to check the selection 
		 // and set the content for the provider.
		 m_listContentArray = setSingleSelect( m_sSelectionArray );
	 }
	 
	 protected ListTableContentProvider setSingleSelect( String[] sSelection )
	 {
		 // Collect up a list of selected keys
		 ArrayList aList = new ArrayList();
		 if( sSelection != null )
			 for( int i =0; i < sSelection.length; i++)
			 {
				 // Something to match up.
				 if( !StringTools.isEmpty( sSelection[i] ))
				 {
					 // Find and set the data as the selected data row.
					 int nIndex = getDataFromSelection( sSelection[i] );
					 if( nIndex > -1 && nIndex < m_DataSource.length )// You found something
						 aList.add( m_DataSource[nIndex] ); // Add it to the list
				 }
			 }
		// Check that you have something to process	 
		if( aList != null && !aList.isEmpty())	 
			 return new ListTableContentProvider( aList );
		 else	 
		 //	No selection then return the results to selection instruction.
		 return new ListTableContentProvider( Arrays.asList( m_EmptySource));
	 }

	 
	 protected int getDataFromSelection( String sSelection )
	 {
		 // Validate the input and find the selection 
		 // from the first element in each data row.
		 if( !StringTools.isEmpty( sSelection ))
		 {
			 try
			 {
				 return Integer.parseInt( sSelection );
			 }
			 catch( NumberFormatException ex)
			 {
				 // send back a -1. 
			 }
		 }
		 return -1;
	 }
	 
	 public void saveSelection()
	 {
		 int forDebugging =0;
		 forDebugging++;
	 }

	 /**
	  * Get the Content Provider for the simple list to use.
	  */
	  public ListTableContentProvider getResultsContentMap()
	  {
		  return m_listContentMap;
	  }

	  /**
	  * Get the Content Provider for the simple list to use.
	  */
	  public ListTableContentProvider getResultsContentList()
	  {
		  return m_listContentList;
	  }

	 /**
	  * Get the Content Provider for the simple list to use.
	  */
	  public ListTableContentProvider getResultsContentArray()
	  {
		  return m_listContentArray;
	  }
}