/**
 * 
 */
package com.webmethods.portlet.simple_list;

import java.util.Arrays;
import java.util.List;

import com.webmethods.caf.common.StringTools;
import com.webmethods.caf.faces.data.object.ListTableContentProvider;

/**
 * @author mitchw
 *
 */
public class Simple_listViewPageBean extends com.webmethods.caf.faces.bean.BasePageBean 
{

	protected String m_sSelectionList = null;
	
	protected Object[] m_DataSource = { new String[]{"Bob",  "1", "BackOrder" },
										new String[]{"Jack", "2", "BackOrder" },
										new String[]{"Jill", "3", "BackOrder" },
										new String[]{"Sue",  "4", "BackOrder" }};

	protected Object[] m_EmptySource = { new String[]{"Select an item",  "", "" }};
	
	protected ListTableContentProvider m_listContentList = null;
	protected ListTableContentProvider m_listContentSelect = new ListTableContentProvider( Arrays.asList( m_EmptySource));

	 /**
	  * Data Sources for the list table content proivder
	  */
	 public List getSourceList()
	 {
		 return Arrays.asList( m_DataSource);
	 }

	 public ListTableContentProvider getListSelect()
	 {
		 return m_listContentSelect;
	 }
	 
		 
	 protected ListTableContentProvider setSingleSelect( String sSelection )
	 {
		 // Something to match up.
		 if( !StringTools.isEmpty( sSelection ))
		 {
			 // Find and set the data as the selected data row.
			 int nIndex = getDataFromSelection( sSelection );
			 if( nIndex > -1 && nIndex < m_DataSource.length )// You found something
				 return new ListTableContentProvider( Arrays.asList( new Object[]{m_DataSource[nIndex]}));
		 }
		 //	No selection then return the results to selection instruction.
		 return new ListTableContentProvider( Arrays.asList( m_EmptySource));
	 }

	 
	 protected int getDataFromSelection( String sSelection )
	 {
		 // Validate the input and find the selection 
		 // from the first element in each data row.
		 if( !StringTools.isEmpty( sSelection ))
		 {
			 for( int i=0; i< m_DataSource.length; i++ )
			 {
				 if( sSelection.equalsIgnoreCase( ((String[])m_DataSource[i])[0] ))
					 return i;
			 }
		 }
		 return -1;
	 }
	 
	 public void saveSelection()
	 {
	 }

	
	  /**
	  * Get the Content Provider for the simple list to use.
	  */
	  public ListTableContentProvider getResultsContentList()
	  {
		  if( m_listContentList == null)	
			  m_listContentList = new ListTableContentProvider( getSourceList());
		  return m_listContentList;
	  }

	  public void updateResults()
	  {
		int nIndex = m_listContentList.getRowIndex();
		List list = m_listContentList.getList();
		Object item = list.get( nIndex );
		if( item instanceof String[] )
		{
			String sKey = ((String[])item)[0];
			int index = getDataFromSelection( sKey );
			if( index > -1 && index < m_DataSource.length )
				m_listContentSelect = new ListTableContentProvider( Arrays.asList( new Object[]{m_DataSource[ index ]}));
			else
				m_listContentSelect = new ListTableContentProvider( Arrays.asList( m_EmptySource));
		}
		else
			m_listContentSelect = new ListTableContentProvider( Arrays.asList( m_EmptySource));
	  }

	/**
	 * Getter method for the control with id='updateResultsLink'
	 */
	public javax.faces.component.html.HtmlCommandLink getUpdateResultsLink()  {
		return (javax.faces.component.html.HtmlCommandLink)findComponentInRoot("updateResultsLink");
	}

}