/**
 * 
 */
package com.webmethods.portlet.table_selection;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;

import javax.faces.context.FacesContext;

import com.webmethods.caf.faces.data.ISelectableTableContentProvider;
import com.webmethods.caf.faces.data.IAddressableTableContentProvider;
import com.webmethods.caf.faces.data.object.SelectableListTableContentProvider;
import com.webmethods.caf.faces.data.object.ListTableContentProvider;

/**
 * @author mitchw
 *
 */
public class Table_selectionViewPageBean extends com.webmethods.caf.faces.bean.BasePageBean 
{
	protected Object[] m_DataSource = { new String[]{"Bob",  "1", "BackOrder" },
										new String[]{"Jack", "2", "BackOrder" },
										new String[]{"Jill", "3", "BackOrder" },
										new String[]{"Sue",  "4", "BackOrder" }};

	protected Object[] m_EmptySource = { new String[]{"Select an item",  "", "" }};
	
//	 Create an empty table and the selection row key ( #{row[0]} )	
	protected SelectableListTableContentProvider m_MultiSelectionContent  = new SelectableListTableContentProvider( Arrays.asList( m_EmptySource), FacesContext.getCurrentInstance().getApplication().createValueBinding("#{row[0]}"));

// Create the table and the selection row key ( #{row[0]} )	
protected SelectableListTableContentProvider m_TableContent
        = new SelectableListTableContentProvider(Arrays.asList(new Object[][] {
            {"Bob",  "1", "BackOrder" },
            {"Jack", "2", "BackOrder" },
            {"Jill", "3", "BackOrder" },
            {"Sue",  "4", "BackOrder" }
    }), FacesContext.getCurrentInstance().getApplication().createValueBinding("#{row[0]}"));
    
   public ISelectableTableContentProvider getTableContent() 
   {
        return m_TableContent;
    }
    
    public String updateSelectionResults()
    {
		ArrayList aList =  new ArrayList( m_TableContent.getRowSelectedIds());
		// m_TableContent.
		if( aList == null || aList.isEmpty() )
		{
			//	Create an empty table and the selection row key ( #{row[0]} )	
			m_MultiSelectionContent = new SelectableListTableContentProvider( Arrays.asList( m_EmptySource), FacesContext.getCurrentInstance().getApplication().createValueBinding("#{row[0]}"));
		}
		else
		{
			//	Create a list of selection from the table and a selection row key ( #{row[0]} )	
			m_MultiSelectionContent = new SelectableListTableContentProvider( findDataInTableList( aList, m_TableContent.getList()), FacesContext.getCurrentInstance().getApplication().createValueBinding("#{row[0]}"));
		}
		return "done";
    }
   
    protected List findDataInTableList( List selectedKey, List sourceList )
    {
    	ArrayList resultsList = new ArrayList();
    	if( sourceList != null && !sourceList.isEmpty() &&
    		selectedKey != null && !selectedKey.isEmpty() )
    	{
    		Object[] oSource = null;
    		for( int i=0; i < selectedKey.size(); i++ )
    		{
    			String sKey = (String)selectedKey.get( i );
    			if( sKey!= null )
    			{
    				for( int j=0; j< sourceList.size(); j++)
    				{
    					oSource = (Object[])sourceList.get( j );
    					if( sKey.equalsIgnoreCase( (String)oSource[0]) )
    						resultsList.add( oSource );
    				}
    			}
    		}
    	}
    	if( resultsList.size() > 0 )
    		return resultsList;
    	
    	return Arrays.asList( m_EmptySource); 
    }
    
     public ListTableContentProvider getMultiSelectionContent()
    {
    	return m_MultiSelectionContent;
    }

/**
 * Getter method for the control with id='SelectionSample'
 */
public com.webmethods.caf.faces.component.table.html.DataTable getSelectionSample()  {
	return (com.webmethods.caf.faces.component.table.html.DataTable)findComponentInRoot("SelectionSample");
}

/**
 * Getter method for the control with id='MutliSelectionTable'
 */
public com.webmethods.caf.faces.component.table.html.DataTable getMutliSelectionTable()  {
	return (com.webmethods.caf.faces.component.table.html.DataTable)findComponentInRoot("MutliSelectionTable");
}

/**
 * Getter method for the control with id='SingleSelectionTable'
 */
public com.webmethods.caf.faces.component.table.html.DataTable getSingleSelectionTable()  {
	return (com.webmethods.caf.faces.component.table.html.DataTable)findComponentInRoot("SingleSelectionTable");
}

/**
 * Getter method for the control with id='Selection'
 */
public com.webmethods.caf.faces.component.table.SelectRowCheckbox getSelection()  {
	return (com.webmethods.caf.faces.component.table.SelectRowCheckbox)findComponentInRoot("Selection");
}

/**
 * Getter method for the control with id='multiSelect'
 */
public com.webmethods.caf.faces.component.table.html.DataTable getMultiSelect()  {
	return (com.webmethods.caf.faces.component.table.html.DataTable)findComponentInRoot("multiSelect");
}

/**
 * Getter method for the control with id='selectBoxes'
 */
public com.webmethods.caf.faces.component.table.SelectRowCheckbox getSelectBoxes()  {
	return (com.webmethods.caf.faces.component.table.SelectRowCheckbox)findComponentInRoot("selectBoxes");
}

/**
 * Getter method for the control with id='CustomerCol'
 */
public com.webmethods.caf.faces.component.table.BaseExtendedColumn getCustomerCol()  {
	return (com.webmethods.caf.faces.component.table.BaseExtendedColumn)findComponentInRoot("CustomerCol");
}

/**
 * Getter method for the control with id='IdCol'
 */
public com.webmethods.caf.faces.component.table.BaseExtendedColumn getIdCol()  {
	return (com.webmethods.caf.faces.component.table.BaseExtendedColumn)findComponentInRoot("IdCol");
}

/**
 * Getter method for the control with id='OrderStatusCol'
 */
public com.webmethods.caf.faces.component.table.BaseExtendedColumn getOrderStatusCol()  {
	return (com.webmethods.caf.faces.component.table.BaseExtendedColumn)findComponentInRoot("OrderStatusCol");
}

/**
 * Getter method for the control with id='ResultsList'
 */
public javax.faces.component.UIPanel getResultsList()  {
	return (javax.faces.component.UIPanel)findComponentInRoot("ResultsList");
}

/**
 * Getter method for the control with id='ResultsListGroup'
 */
public javax.faces.component.UIPanel getResultsListGroup()  {
	return (javax.faces.component.UIPanel)findComponentInRoot("ResultsListGroup");
}
 

}