/**
 * 
 */
package com.webmethods.portlet.addressorder;

import java.util.Locale;
import java.util.Vector;

import com.webmethods.caf.faces.data.object.ListTableContentProvider;
import com.wm.g11n.text.formatter.AddressFormatter;
import com.wm.g11n.text.formatter.AddressStyleEntity;
import com.wm.g11n.text.formatter.FormatterException;
import com.wm.g11n.util.iContext;

/**
 * @author mitchw
 *
 */
public class AddressOrderDefaultviewView extends com.webmethods.caf.faces.bean.BasePageBean {

	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	private com.webmethods.portlet.addressorder.AddressOrder addressOrder = null;
	public static final String CITY = "City";
	public static final String DISTRICT = "District";
	public static final String COUNTRY = "Country";
	public static final String ADDRESS1 = "Address1";
	public static final String ADDRESS2 = "Address2";
	public static final String POSTOFFICE = "Post Office";
	public static final String POSTCODE = "Post Code";
	
	public static final String PROVINCE = "Province";
	public static final String STATE = "State";
	public static final String REGIONID = "";


	public com.webmethods.portlet.addressorder.AddressOrder getAddressOrder()  {
		if (addressOrder == null) {
		    addressOrder = (com.webmethods.portlet.addressorder.AddressOrder)resolveExpression("#{AddressOrder}");
		}
		return addressOrder;
	}

	protected Locale getJP()
	{
		return new Locale( "ja", "JP" );
	}

	protected Locale getUS()
	{
		return new Locale( "en", "US" );
	}
	
	public String getNameInOrderJP()
	{
		return getAddressInOrder( getJP());
	}
	public String getNameInOrderUS()
	{
		return getAddressInOrder( getUS() );
	}
	protected String getAddressInOrder( Locale locValue )
	{
		//NameFormatter nameFormatter = new NameFormatter(null, null, null, null, null, "JP");;
		iContext context = new iContext( locValue );
		// Create name formater and set the territory
		AddressFormatter addressFormatter = new AddressFormatter();
		addressFormatter.setIContext( context );
		addressFormatter.setFromTerritoryCode( "" );
		addressFormatter.setLineBreak( "<BR/>" );
		// Get Values from inputs of names.
		//	Construct entity to be formatted
		AddressStyleEntity entity = getAddressStyleEntity( locValue );
		try
		{
			String formattedAddr = addressFormatter.getFormattedResultInline( entity );
			return formattedAddr;
		}
		catch( FormatterException ex )
		{
			return ex.getMessage();
		}
	}

	protected AddressStyleEntity getAddressStyleEntity( Locale locValue )
	{
		//	Construct entity to be formatted
		AddressStyleEntity entity = new AddressStyleEntity();      
		// set the entity type and entity values
        entity.setAddressLine1( ADDRESS1 ); 
        entity.setAddressLine2( ADDRESS2 );
        entity.setAddressLine3( "Address3");
    	entity.setAddressLine4( "Address4" );
    	entity.setAddressLinesPhonetic( "Addr Phonetic");
    	entity.setAddressProvince( PROVINCE );
    	entity.setAddressState( STATE );
    	entity.setCity( CITY );
    	entity.setCounty( COUNTRY );
    	entity.setCountryRegionID( locValue.getCountry() );
    	entity.setDepartment( "Department");
    	entity.setDistrict( DISTRICT );
    	entity.setIsland( "Island");
    	entity.setParish( "Parish" );
    	entity.setPostalCode( POSTCODE );		
        entity.setPostOffice( POSTOFFICE );		
        entity.setRegion( locValue.getDisplayCountry() );

        return entity;
	}

	public ListTableContentProvider getJpAddressAsTableContent()
	{
		return getAddressAsTableContent( getJP() );
	}

	public ListTableContentProvider getUsAddressAsTableContent()
	{
		return getAddressAsTableContent( getUS() );
	}	

	protected ListTableContentProvider getAddressAsTableContent( Locale locValue )
	{
		//NameFormatter nameFormatter = new NameFormatter(null, null, null, null, null, "JP");;
		iContext context = new iContext( locValue );
		// Create name formater and set the territory
		AddressFormatter addressFormatter = new AddressFormatter();
		addressFormatter.setIContext( context );
		addressFormatter.setFromTerritoryCode( "" );
	//	addressFormatter.setLineBreak( "<BR/>" );
		// Get Values from inputs of names.
		//	Construct entity to be formatted
		AddressStyleEntity entity = getAddressStyleEntity( locValue );
		try
		{
			Vector vAddrFromatted = addressFormatter.getFormattedResult( entity );
			return new ListTableContentProvider( vAddrFromatted );
		}
		catch( FormatterException ex )
		{
			
		}
		return new ListTableContentProvider( );
		
	}
//	protected ListTableContentProvider m_listContentSelect = new ListTableContentProvider( Arrays.asList( m_EmptySource));	
}