/**
 * 
 */
package com.webmethods.portlet.nameorder;

import java.util.Iterator;
import java.util.Locale;
import java.util.Vector;

import com.wm.g11n.text.formatter.DAOException;
import com.wm.g11n.text.formatter.DefaultSetting;
import com.wm.g11n.text.formatter.FormatLayout;
import com.wm.g11n.text.formatter.FormatLayoutAttribute;
import com.wm.g11n.text.formatter.FormatterException;
import com.wm.g11n.text.formatter.NameFormatter;
import com.wm.g11n.text.formatter.NameStyleEntity;
import com.wm.g11n.text.formatter.XmlDataAccessObject;
import com.wm.g11n.util.iContext;

/**
 * @author mitchw
 *
 */
public class NameOrderDefaultviewView extends com.webmethods.caf.faces.bean.BasePageBean {

	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	private com.webmethods.portlet.nameorder.NameOrder nameOrder = null;
	
	protected String m_sFirstName = null;
	protected String m_sLastName  = null;

	public com.webmethods.portlet.nameorder.NameOrder getNameOrder()  {
		if (nameOrder == null) {
		    nameOrder = (com.webmethods.portlet.nameorder.NameOrder)resolveExpression("#{NameOrder}");
		}
		return nameOrder;
	}
	
	public String getFirstName()
	{
		return m_sFirstName;
	}
	public void setFirstName(String sValue )
	{
		m_sFirstName = sValue;
	}
	public String getLastName()
	{
		return m_sLastName;
	}
	public void setLastName(String sValue )
	{
		m_sLastName = sValue;
	}
	public String getNameInLocJP()
	{
		return getNameInOrder( getLocaleJP());
	}

	public String getNameInLocUS()
	{
		return getNameInOrder( getLocaleUS());
	}

	protected String getNameInOrder( Locale locValue )
	{
		//NameFormatter nameFormatter = new NameFormatter(null, null, null, null, null, "JP");;
		iContext context = new iContext( locValue );
		// Create name formater and set the territory
		NameFormatter nameFormatter = new NameFormatter();
		nameFormatter.setIContext( context );
		// Get Values from inputs of names.
		//	Construct entity to be formatted
		NameStyleEntity entity = new NameStyleEntity();      
		// set the entity type and entity values
		if( getFirstName() != null )
			entity.setFirstName( getFirstName() );
		if( getLastName() != null )
			entity.setLastName( getLastName() );
		// format		return "first Last";
		try
		{
			String formattedName = nameFormatter.getFormattedResultInline( entity );
			return formattedName;
		}
		catch( FormatterException ex )
		{
			return ex.getMessage();
		}
	}

	public String getFormattedNameInLocJP()
	{
		return getNameInFormattedOrder( getLocaleJP());
	}

	public String getFormattedNameInLocUS()
	{
		return getNameInFormattedOrder( getLocaleUS());
	}
	
	protected String getNameInFormattedOrder( Locale locValue )
	{
		// Create name formater and set the territory
		iContext context = new iContext( locValue );
		// Create name formater and set the territory
		NameFormatter nameFormatter = new NameFormatter();
		nameFormatter.setIContext( context );
		nameFormatter.setLineBreak( "<br>" );
		// Get Values from inputs of names.
		//	Construct entity to be formatted
		NameStyleEntity entity = new NameStyleEntity();      
		// set the entity type and entity values
		if( getFirstName() != null )
			entity.setFirstName( getFirstName() );
		if( getLastName() != null )
			entity.setLastName( getLastName() );
		// format		return "first Last";
		try
		{
			String formattedName = nameFormatter.getFormattedResultInline( entity );
			return formattedName;
		}
		catch( FormatterException ex )
		{
			return ex.getMessage();
		}
	}
	
	public boolean isFirstNameFirstInLocJP()
	{
		return isFirstNameFirst( getLocaleJP());
	}

	public boolean isFirstNameFirstInLocUS()
	{
		return isFirstNameFirst( getLocaleUS());
	}
	public boolean isLastNameLastInLocJP()
	{
		return isLastNameLast( getLocaleJP());
	}

	public boolean isLastNameLastInLocUS()
	{
		return isLastNameLast( getLocaleUS());
	}
	/**
	 * To show you how to get a list of the attribute's Keys in there display order.
	 * This is instead of just getting the attribute's Values in the display order. 
	 * @param locValue Input the region/country you want the format order for.
	 * @return Is the first name element the first in the order list.
	 */
	protected  boolean isFirstNameFirst( Locale locValue )
	{
		return isInThisOrder( locValue, 
				  NameStyleEntity.FIRSTNAME,
				  NameStyleEntity.LASTNAME );
	}

	/**
	 * To show you how to get a list of the attribute's Keys in there display order.
	 * This is instead of just getting the attribute's Values in the display order. 
	 * @param locValue Input the region/country you want the format order for.
	 * @return Is the first name element the first in the order list.
	 */
	protected  boolean isLastNameLast( Locale locValue )
	{
		return isInThisOrder( locValue, 
				    		  NameStyleEntity.FIRSTNAME,
							  NameStyleEntity.LASTNAME );
	}

	/**
	 * To show you how to get a list of the attribute's Keys in there display order.
	 * This is instead of just getting the attribute's Values in the display order. 
	 * @param locValue Input the region/country you want the format order for.
	 * @return Is the first name element the first in the order list.
	 */
	protected  boolean isInThisOrder( Locale locValue, String sFirstValue, String sLastValue )
	{
	    Vector formatLayoutsAttrs = null;
		XmlDataAccessObject xDataAccObj = new XmlDataAccessObject();
		try
		{
			// Using the XmlDataAccessObject
			// Setup the defaults
			DefaultSetting df = xDataAccObj.getDefaultSetting(NameStyleEntity.STYLE_ENTITY_TYPE);
			// Then get the style for your region/contry.
			String styleFormatCode = xDataAccObj.getStyleFormatCode(df.getDefaultStyle(), locValue.getLanguage(), locValue.getCountry());
			// Get the list of formats
		    Vector styleFormatLayouts = xDataAccObj.getFormatLayouts(styleFormatCode);
		    // Take the first one
		    FormatLayout formatLayout = (FormatLayout)styleFormatLayouts.get( 0 );
		    // Get a list of the layouts attribute in display order.
		    formatLayoutsAttrs = formatLayout.getFormatLayoutAttributes();
		}
		catch( DAOException dbBad )
		{
			return false;
		}
		Iterator it = formatLayoutsAttrs.iterator();
		FormatLayoutAttribute flAttr = null;
		// Did you get back any attributes and was First Value Before Last Value.
		int nFirst = -1;
		int nLast = -1;
		while( it.hasNext() )
		{
			flAttr = (FormatLayoutAttribute)it.next();
			if( sLastValue.equalsIgnoreCase( flAttr.getAttributeCode() ))
				nLast = flAttr.getPosition();
			if( sFirstValue.equalsIgnoreCase( flAttr.getAttributeCode() ))
				nFirst = flAttr.getPosition();
		}
		if( nLast > nFirst )
			return true;
		// Found Last before first or first is not in the list.
		return false;
	}
	
	protected Locale getLocaleJP()
	{
		return new Locale("ja", "JP" );
	}
	protected Locale getLocaleUS()
	{
		return new Locale("en", "US" );
	}

	public String returnOK()
	{
		return "OK";
	}
}