CREATE FUNCTION fnKeyRank (@key1 varchar(500), @key2 varchar(500))  
RETURNS int AS  
BEGIN 
  declare @idx int
  set @idx = 1
  declare @len int
  set @len = len(@key1)
  if @len > len(@key2) set @len = len(@key2)

  while @idx <= @len and substring(@key1, @idx, 1) = substring(@key2, @idx, 1)
  begin
    set @idx = @idx + 1
  end

  return case when @idx > len(@key2) - 20 then 10 when @idx > len(@key2) - 40 then  2 when @idx <= 20 then 0 else 1 end
END
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('fnKeyRank', 'FUNCTION')
GO

CREATE PROCEDURE spLoadRelatedPages(@dbid int)
AS
BEGIN
    select top 100 * from (select x.idthingxtype, thingID_1, rank * dbo.fnKeyRank(tr1.treekey, tr2.treekey)  rank from
	(select thingID_1,  count(*) rank 
		from tblwEvents e1
		where e1.idType = 3 and 
	               exists (select * from tblwEvents e2 where e2.userID = e1.userID and thingID_1 = @dbid and abs(e2.timestamp - e1.timestamp) < 3 * 60 * 1000)
		group by thingID_1) r, tbltree tr1, tbltree tr2, tblThing x
		where tr2.idThing = @dbid and tr1.idThing = thingID_1 and x.idThing = thingID_1 and thingID_1 <> @dbid) t where rank > 0
		order by rank desc
END
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('spLoadRelatedPages', 'PROCEDURE')
GO
