CREATE OR REPLACE FUNCTION fnKeyRank (key1 varchar2, key2 varchar2)
    RETURN INT
AS
   p_idx INT;
   p_len INT;
BEGIN
    p_idx := 1;
    p_len := length(key1);
    if p_len > length(key2) then
        p_len := length(key2);
    end if;
    
    while (p_idx <= p_len) and (substr(key1, p_idx, 1) = substr(key2, p_idx, 1))
    loop
        p_idx := p_idx + 1;
    end loop;
    
    return case when p_idx > length(key2) - 20 then 10 when p_idx > length(key2) - 40 then 2 when p_idx <= 20 then 0 else 1 end;

END fnKeyRank ;
/ 

INSERT INTO MWS_DYN_OBJECTS VALUES ('fnKeyRank', 'FUNCTION')
/

CREATE OR REPLACE PACKAGE spLoadRelatedPages AS
TYPE o_cursor_rec IS RECORD (
        idThingXType    tblThing.idThingXType%TYPE,
        idThing         tblThing.idThing%TYPE     ,
        rank            INT
);
TYPE o_cursor IS REF CURSOR return o_cursor_rec;
function spLoadRelatedPages (pidThing INT) return o_cursor;
END spLoadRelatedPages;
/ 

CREATE OR REPLACE PACKAGE BODY spLoadRelatedPages
AS
function spLoadRelatedPages (pidThing INT) return o_cursor
IS
r o_cursor;
BEGIN
    OPEN r for
        select * from (select x.idthingxtype, thingID_1, rank * fnKeyRank(tr1.treekey, tr2.treekey)  rank from
            (select thingID_1,  count(*) rank 
                from tblwEvents e1
                where e1.idType = 3 and 
                           exists (select * from tblwEvents e2 where e2.userID = e1.userID and thingID_1 = pidThing and abs(e2.timestamp - e1.timestamp) < 3 * 60 * 1000)
                group by thingID_1) r, tbltree tr1, tbltree tr2, tblThing x
                where tr2.idThing = pidThing and tr1.idThing = thingID_1 and x.idThing = thingID_1 and thingID_1 <> pidThing) t where rank > 0
                order by rank desc;
                
    RETURN (r);

END spLoadRelatedPages;
END spLoadRelatedPages;
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('spLoadRelatedPages', 'PACKAGE')
/
