CREATE TABLE DBDIR_USERS (
    USERNAME VARCHAR2(128) NOT NULL,
    PASSWORD VARCHAR2(128) NOT NULL,
    FIRSTNAME VARCHAR2(128) NOT NULL,
    LASTNAME VARCHAR2(128) NOT NULL,
    EMAIL VARCHAR2(128),
    ADDRESS VARCHAR2(255),
    CITY VARCHAR2(128),
    STATE VARCHAR2(2),
    ZIPCODE VARCHAR2(9)
)
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_USERS', 'TABLE')
/

INSERT INTO DBDIR_USERS VALUES ('eng1', 'eng1', 'Engineer', 'One', 'eng1@mycompany.com', '111 11th St', 'Seattle', 'WA', '98001')
/
INSERT INTO DBDIR_USERS VALUES ('eng2', 'eng2', 'Engineer', 'Two', 'eng2@mycompany.com', '222 22th St', 'Seattle', 'WA', '98002')
/
INSERT INTO DBDIR_USERS VALUES ('eng3', 'eng3', 'Engineer', 'Three', 'eng3@mycompany.com', '333 33th St', 'Seattle', 'WA', '98003')
/
INSERT INTO DBDIR_USERS VALUES ('eng4', 'eng4', 'Engineer', 'Four', 'eng4@mycompany.com', '444 44th St', 'Seattle', 'WA', '98004')
/
INSERT INTO DBDIR_USERS VALUES ('eng5', 'eng5', 'Engineer', 'Five', 'eng5@mycompany.com', '555 55th St', 'Seattle', 'WA', '98005')
/
INSERT INTO DBDIR_USERS VALUES ('manager1', 'manager1', 'Manager', 'One', 'manager1@mycompany.com', '666 66th St', 'Seattle', 'WA', '98006')
/
INSERT INTO DBDIR_USERS VALUES ('manager2', 'manager2', 'Manager', 'Two', 'manager2@mycompany.com', '777 77th St', 'Seattle', 'WA', '98007')
/

CREATE TABLE DBDIR_GROUPS (
    GROUPNAME VARCHAR2(128) NOT NULL,
    NAME VARCHAR2(128) NOT NULL,
    EMAIL VARCHAR2(128)
)
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_GROUPS', 'TABLE')
/

INSERT INTO DBDIR_GROUPS VALUES ('development', 'Development', 'development@mycompany.com')
/
INSERT INTO DBDIR_GROUPS VALUES ('productmanagement', 'Product Management', 'productmanagement@mycompany.com')
/

CREATE TABLE DBDIR_USERMEMBERSHIP (
    GROUPNAME VARCHAR2(128) NOT NULL,
    USERNAME VARCHAR2(128) NOT NULL
)
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_USERMEMBERSHIP', 'TABLE')
/

INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng1')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng2')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng3')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng4')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng5')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('productmanagement', 'manager1')
/
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('productmanagement', 'manager2')
/

CREATE TABLE DBDIR_GROUPMEMBERSHIP (
    PARENTGROUPNAME VARCHAR2(128) NOT NULL,
    CHILDGROUPNAME VARCHAR2(128) NOT NULL
)
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_GROUPMEMBERSHIP', 'TABLE')
/

INSERT INTO DBDIR_GROUPMEMBERSHIP VALUES ('development', 'productmanagement')
/

CREATE TABLE DBDIR_ROLES (
    IDROLE VARCHAR2(128),
    IDUSER VARCHAR2(128)
)
/

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_ROLES', 'TABLE')
/

INSERT INTO DBDIR_ROLES VALUES ('administrator', 'manager1')
/
INSERT INTO DBDIR_ROLES VALUES ('administrator', 'manager2')
/
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng1')
/
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng5')
/
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng4')
/
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng3')
/
