CREATE TABLE DBDIR_USERS (
    USERNAME NVARCHAR(128) NOT NULL,
    PASSWORD NVARCHAR(128) NOT NULL,
    FIRSTNAME NVARCHAR(128) NOT NULL,
    LASTNAME NVARCHAR(128) NOT NULL,
    EMAIL NVARCHAR(128),
    ADDRESS NVARCHAR(255),
    CITY NVARCHAR(128),
    STATE NVARCHAR(2),
    ZIPCODE NVARCHAR(9)
)
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_USERS', 'TABLE')
GO

INSERT INTO DBDIR_USERS VALUES ('eng1', 'eng1', 'Engineer', 'One', 'eng1@mycompany.com', '111 11th St', 'Seattle', 'WA', '98001')
GO
INSERT INTO DBDIR_USERS VALUES ('eng2', 'eng2', 'Engineer', 'Two', 'eng2@mycompany.com', '222 22th St', 'Seattle', 'WA', '98002')
GO
INSERT INTO DBDIR_USERS VALUES ('eng3', 'eng3', 'Engineer', 'Three', 'eng3@mycompany.com', '333 33th St', 'Seattle', 'WA', '98003')
GO
INSERT INTO DBDIR_USERS VALUES ('eng4', 'eng4', 'Engineer', 'Four', 'eng4@mycompany.com', '444 44th St', 'Seattle', 'WA', '98004')
GO
INSERT INTO DBDIR_USERS VALUES ('eng5', 'eng5', 'Engineer', 'Five', 'eng5@mycompany.com', '555 55th St', 'Seattle', 'WA', '98005')
GO
INSERT INTO DBDIR_USERS VALUES ('manager1', 'manager1', 'Manager', 'One', 'manager1@mycompany.com', '666 66th St', 'Seattle', 'WA', '98006')
GO
INSERT INTO DBDIR_USERS VALUES ('manager2', 'manager2', 'Manager', 'Two', 'manager2@mycompany.com', '777 77th St', 'Seattle', 'WA', '98007')
GO

CREATE TABLE DBDIR_GROUPS (
    GROUPNAME NVARCHAR(128) NOT NULL,
    NAME NVARCHAR(128) NOT NULL,
    EMAIL NVARCHAR(128)
)
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_GROUPS', 'TABLE')
GO

INSERT INTO DBDIR_GROUPS VALUES ('development', 'Development', 'development@mycompany.com')
GO
INSERT INTO DBDIR_GROUPS VALUES ('productmanagement', 'Product Management', 'productmanagement@mycompany.com')
GO

CREATE TABLE DBDIR_USERMEMBERSHIP (
    GROUPNAME NVARCHAR(128) NOT NULL,
    USERNAME NVARCHAR(128) NOT NULL
)
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_USERMEMBERSHIP', 'TABLE')
GO

INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng1')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng2')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng3')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng4')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('development', 'eng5')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('productmanagement', 'manager1')
GO
INSERT INTO DBDIR_USERMEMBERSHIP VALUES ('productmanagement', 'manager2')
GO

CREATE TABLE DBDIR_GROUPMEMBERSHIP (
    PARENTGROUPNAME NVARCHAR(128) NOT NULL,
    CHILDGROUPNAME NVARCHAR(128) NOT NULL
)
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_GROUPMEMBERSHIP', 'TABLE')
GO

INSERT INTO DBDIR_GROUPMEMBERSHIP VALUES ('development', 'productmanagement')
GO

CREATE TABLE DBDIR_ROLES (
    IDROLE NVARCHAR(128),
    IDUSER NVARCHAR(128)
)
GO

INSERT INTO MWS_DYN_OBJECTS VALUES ('DBDIR_ROLES', 'TABLE')
GO

INSERT INTO DBDIR_ROLES VALUES ('administrator', 'manager1')
GO
INSERT INTO DBDIR_ROLES VALUES ('administrator', 'manager2')
GO
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng1')
GO
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng5')
GO
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng4')
GO
INSERT INTO DBDIR_ROLES VALUES ('contributor', 'eng3')
GO
