/**
 ** Copyright (c) 2001-2004 webMethods, Inc. All Rights Reserved.
 **/
package com.webmethods.portal.portlet.wm_dbdir_sample.mechanics;

import com.webmethods.portal.service.meta2.thing.IThingID;
import com.webmethods.portal.service.sql.core.ConnectionManager;
import com.webmethods.portal.service.sql.ISqlWorker;
import com.webmethods.portal.PortalException;
import com.webmethods.portal.system.PortalSystem;
import com.webmethods.portal.system.IURI;
import com.webmethods.portal.bizPolicy.biz.system.impl.SystemPolicy;
import com.webmethods.portal.bizPolicy.biz.IBizPolicyManager;
import com.webmethods.portal.bizPolicy.biz.IBizPolicyNames;
import com.webmethods.portal.bizPolicy.impl.ContextFactory;
import com.webmethods.portal.bizPolicy.IContext;
import com.webmethods.rtl.util.xml.XMLUtil;
import org.w3c.dom.Document;

/**
 * This is the implementation of your {@link com.webmethods.portal.mech.IMechanics}
 *
 * @version    $Revision: 1.0 $
 */
public class Dbdir_sampleMechanics extends com.webmethods.portal.mech.portlet.impl.PortletMechanics {
    public void doAfterInstall(IThingID itemID) throws PortalException {
        // depending on database server version install appropriate xmlImport.xml
        String serverType = ConnectionManager.getConnInfo("").getServerType();
        String xmlImportFile = null;
        if (ISqlWorker.SERVERTYPE_MSSQL_STR.equals(serverType)) {
            xmlImportFile = "deploytemp:/resources/mssql/xmlImport.xml";
        }
        else if (ISqlWorker.SERVERTYPE_ORACLE_STR.equals(serverType)) {
            xmlImportFile = "deploytemp:/resources/oracle/xmlImport.xml";
        }
        else if (ISqlWorker.SERVERTYPE_DB2_STR.equals(serverType)) {
            xmlImportFile = "deploytemp:/resources/db2/xmlImport.xml";
        }
        else if (ISqlWorker.SERVERTYPE_SYBASE_STR.equals(serverType)) {
            xmlImportFile = "deploytemp:/resources/sybase/xmlImport.xml";
        }

        if (xmlImportFile != null) {
            Document doc = XMLUtil.loadDocument(xmlImportFile);
            IContext context = ContextFactory.acquireContext(true);
            SystemPolicy systemPolicy = (SystemPolicy) ((IBizPolicyManager)PortalSystem.getBizPolicyProvider()).
                    getBizPolicy(IBizPolicyNames.SYSTEM);
            IURI parentURI = PortalSystem.getPortalSystem().acquireURI("folder.root");
            systemPolicy.xmlImport(context, doc.getDocumentElement(), parentURI);
        }
    }
}