package com.webmethods.caf.perfserviceclient;

import com.webmethods.caf.Wm_perfserviceclient;
import com.webmethods.rtl.util.PerfUtil;

class CustomApiClient {

    private static final String PERF_TOKEN_PREFIX = "customapiclient" + Wm_perfserviceclient.PERF_TOKEN_SEPARATOR;

    private static Object slowSubroutineToken;

    private static Object mediumSlowSubroutineToken;

    private static Object verySlowSubroutineToken;

    static {
        // initialize all performance tokens once
        slowSubroutineToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "slowSubroutine");
        mediumSlowSubroutineToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "mediumSlowSubroutine");
        verySlowSubroutineToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "verySlowSubroutine");
    }

    void verySlowSubroutine() {
        try {
            PerfUtil.actionStart(verySlowSubroutineToken);
            FileSystemClient fileSystemClient = new FileSystemClient();
            for (int i = 0; i < 15; i++) {
                fileSystemClient.write();
            }
        }
        finally {
            PerfUtil.actionEnd(verySlowSubroutineToken);
        }
        

    }

    void slowSubroutine() {

        try {
            PerfUtil.actionStart(slowSubroutineToken);
            Thread.sleep(5000);
        }
        catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        finally {
            PerfUtil.actionEnd(slowSubroutineToken);
        }

    }

    void mediumSlowSubroutine() {
        try {
            PerfUtil.actionStart(mediumSlowSubroutineToken);
            Thread.sleep(2500);
        }
        catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        finally {
            PerfUtil.actionEnd(mediumSlowSubroutineToken);
        }

    }

}
