/**
 * 
 */
package com.webmethods.caf.perfserviceclient;

import com.webmethods.caf.Wm_perfserviceclient;
import com.webmethods.rtl.util.PerfUtil;

/**
 * @author bgsge
 * 
 */

public class PerfServiceClientDefaultviewView extends com.webmethods.caf.faces.bean.BasePageBean {

    private static final String PERF_TOKEN_PREFIX = "perfserviceclient" + Wm_perfserviceclient.PERF_TOKEN_SEPARATOR;

    /**
     * Determines if a de-serialized file is compatible with this class.
     * 
     * Maintainers must change this value if and only if the new version of this class is not compatible with old
     * versions. See Sun docs for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html>
     * details. </a>
     */
    private static final long serialVersionUID = 1L;

    private static final String[][] INITIALIZE_PROPERTY_BINDINGS = new String[][] {};

    private com.webmethods.caf.perfserviceclient.PerfServiceClient perfServiceClient = null;

    private CustomApiClient customApiClient;

    private Object slowActionButtonToken;

    private Object mediumSlowActionButtonToken;

    private Object slowStringConcantToken;

    private Object invokeCustomApiSlowMethodToken;

    private Object verySlowActionButton_actionToken;

    private Object slowStringConcatPart1Token;

    private Object slowStringConcatPart2Token;

    /**
     * Initialize page
     */
    public String initialize() {
        // initialize all performance tokens once
        mediumSlowActionButtonToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "mediumSlowActionButton_action");
        slowActionButtonToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "slowActionButton_action");
        verySlowActionButton_actionToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "verySlowActionButton_action");

        slowStringConcantToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "slowStringConcant");
        slowStringConcatPart1Token = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "slowStringConcant" + Wm_perfserviceclient.PERF_TOKEN_SEPARATOR + "part1");
        slowStringConcatPart2Token = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "slowStringConcant" + Wm_perfserviceclient.PERF_TOKEN_SEPARATOR + "part2");

        invokeCustomApiSlowMethodToken = PerfUtil.actionInit(Wm_perfserviceclient.PERF_CATEGORY, PERF_TOKEN_PREFIX
            + "invokeCustomApiSlowMethod");
        try {
            resolveDataBinding(INITIALIZE_PROPERTY_BINDINGS, null, "initialize", true, false);

            customApiClient = new CustomApiClient();

            return OUTCOME_OK;
        }
        catch (Exception e) {
            error(e);
            log(e);
            return OUTCOME_ERROR;
        }
    }

    public com.webmethods.caf.perfserviceclient.PerfServiceClient getPerfServiceClient() {
        if (perfServiceClient == null) {
            perfServiceClient = (com.webmethods.caf.perfserviceclient.PerfServiceClient) resolveExpression("#{PerfServiceClient}");
        }
        return perfServiceClient;
    }

    /**
     * Action Event Handler for the control with id='mediumSlowActionButton'
     */
    public String mediumSlowActionButton_action() {
        try {
            PerfUtil.actionStart(mediumSlowActionButtonToken);
            customApiClient.mediumSlowSubroutine();

            return OUTCOME_OK;

        }
        finally {
            PerfUtil.actionEnd(mediumSlowActionButtonToken);
        }
    }

    /**
     * Action Event Handler for the control with id='slowActionButton'
     */
    public String slowActionButton_action() {
        try {
            PerfUtil.actionStart(slowActionButtonToken);

            slowStringConcant();

            invokeCustomApiSlowMethod();

            return OUTCOME_OK;

        }
        finally {
            PerfUtil.actionEnd(slowActionButtonToken);
        }
    }

    /**
     * create thousands of string objects
     */
    private void slowStringConcant() {
        try {
            PerfUtil.actionStart(slowStringConcantToken);

            try {
                PerfUtil.actionStart(slowStringConcatPart1Token);
                String concat = "";
                for (int i = 0; i < 5000; i++) {
                    concat += i + " | ";
                }
            }
            finally {
                PerfUtil.actionEnd(slowStringConcatPart1Token);

            }

            try {
                PerfUtil.actionStart(slowStringConcatPart2Token);
                String concat = "";
                for (int i = 0; i < 10000; i++) {
                    concat += i + " | ";
                }
            }
            finally {
                PerfUtil.actionEnd(slowStringConcatPart2Token);

            }

        }
        finally {
            PerfUtil.actionEnd(slowStringConcantToken);
        }
    }

    /**
     * Call API subroutine
     */
    private void invokeCustomApiSlowMethod() {
        try {
            PerfUtil.actionStart(invokeCustomApiSlowMethodToken);
            customApiClient.slowSubroutine();

        }
        finally {
            PerfUtil.actionEnd(invokeCustomApiSlowMethodToken);
        }
    }

    /**
     * Action Event Handler for the control with id='verySlowActionButton'
     */
    public String verySlowActionButton_action() {
        try {
            PerfUtil.actionStart(verySlowActionButton_actionToken);
            customApiClient.verySlowSubroutine();

            return OUTCOME_OK;

        }
        finally {
            PerfUtil.actionEnd(verySlowActionButton_actionToken);
        }
    }

}