/**
 * 
 */
package com.webmethods.caf.ordercreditinboxresults;

/**
 * @author oleksiyo
 *
 */

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.model.SelectItem;

import com.webmethods.caf.faces.component.dir.PrincipalPickerModalDialog;
import com.webmethods.caf.faces.component.util.ComponentUtils;
import com.webmethods.caf.faces.context.ContextUtils;
import com.webmethods.caf.faces.data.dir.PrincipalModel;
import com.webmethods.caf.faces.data.task.ITaskInfo;
import com.webmethods.caf.faces.data.task.TaskDisplayProvider;
import com.webmethods.caf.faces.data.task.TaskProviderUtils;
import com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended;
import com.webmethods.caf.faces.data.task.impl.TaskSearchQueryTerm;

public class OrderCreditInboxResultsDefaultviewView extends com.webmethods.caf.faces.bean.task.BaseTaskInboxResultPageBean {

	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;

	private TaskDisplayProvider taskDisplayProvider = null;

	protected TaskSearchQueryTerm m_typeID = new TaskSearchQueryTerm();
	protected TaskContentProviderExtended m_taskContentProvider;
	protected PrincipalModel m_delegatePrincipal = null;
	
	private com.webmethods.caf.faces.data.object.TableSelectItemGroupProvider taskTypeNameMapProvider = null;
	private static final String[][] TASKTYPENAMEMAPPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskTypeNameMapProvider.labelFieldName}", "label"},
		{"#{TaskTypeNameMapProvider.array}", "#{TaskDisplayProvider.taskTypeItems}"},
		{"#{TaskTypeNameMapProvider.valueFieldName}", "value"},
	};
	
	private static final String[][] TASKDISPLAYPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskDisplayProvider.taskInfo}", "#{row.taskInfo}"},
	};

	public TaskDisplayProvider getTaskDisplayProvider()  {
		if (taskDisplayProvider == null) {
		    taskDisplayProvider = (TaskDisplayProvider)resolveExpression("#{TaskDisplayProvider}");
		}
	
	    resolveDataBinding(TASKDISPLAYPROVIDER_PROPERTY_BINDINGS, taskDisplayProvider, "this", true, false);
		return taskDisplayProvider;
	}
	
	private com.webmethods.caf.faces.data.object.ListTableContentProvider selectedTaskInfosProvider = null;
	private static final String[][] SELECTEDTASKINFOSPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{SelectedTaskInfosProvider.list}", "#{activePageBean.selectedTaskInfos}"},
		{"#{SelectedTaskInfosProvider.rowVariable}", "varselectedTaskInfo"},
	};

	private com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended taskContentProviderExtended = null;
	private static final String[][] TASKCONTENTPROVIDEREXTENDED_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskContentProviderExtended.taskID}", "#{row.taskID}"},
	};

	private static final String[][] TASKCONTENTPROVIDEREXTENDEDFORLIST_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskContentProviderExtended.taskID}", "#{selectedTaskRow.taskID}"},
	};

	private TaskDisplayProvider taskDisplayProviderForDialog = null;
	private static final String[][] TASKDISPLAYPROVIDERFORDIALOG_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskDisplayProviderForDialog.taskID}", "#{selectedTaskRow.taskID}"},
	};

	private com.webmethods.caf.ordercreditinboxresults.OrderCreditInboxResults orderCreditInboxResults = null;

	private com.webmethods.caf.ordercreditinboxresults.OrderCreditSearchProvider taskSearchProvider = null;

	private static final String[][] TASKSEARCHPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{taskSearchProvider.rowIdBinding}", "#{row.taskInfo.taskID}"},
		{"#{taskSearchProvider.searchQuery.taskID.value}", "#{activePageBean.activeSearchQuery.refineFields.taskID}"},
		{"#{taskSearchProvider.searchQuery.priority.value}", "#{activePageBean.activeSearchQuery.refineFields.priority}"},
		{"#{taskSearchProvider.searchQuery.createdDateRange}", "#{activePageBean.activeSearchQuery.refineFields.createdDateRange}"},
		{"#{taskSearchProvider.searchQuery.modifiedDateRange}", "#{activePageBean.activeSearchQuery.refineFields.modifiedDateRange}"},
		{"#{taskSearchProvider.searchQuery.expirationDateRange}", "#{activePageBean.activeSearchQuery.refineFields.expirationDateRange}"},
		{"#{taskSearchProvider.searchQuery.acceptedByCurrent.value}", "#{activePageBean.activeSearchQuery.refineFields.acceptedByCurrentUser}"},
		{"#{taskSearchProvider.searchQuery.maxResults}", "#{activePageBean.activeSearchQuery.maxResults}"},
		{"#{taskSearchProvider.searchQuery.orderID.operator}", "="},
		{"#{taskSearchProvider.searchQuery.orderID.value}", "#{activePageBean.activeSearchQuery.refineFields[\"orderID\"]}"},
		{"#{taskSearchProvider.searchQuery.orderID.fieldBinding}", "#{currentTask.taskData.orderID}"},
	};

	public com.webmethods.caf.faces.data.object.TableSelectItemGroupProvider getTaskTypeNameMapProvider()  {
		if (taskTypeNameMapProvider == null) {
		    taskTypeNameMapProvider = (com.webmethods.caf.faces.data.object.TableSelectItemGroupProvider)resolveExpression("#{TaskTypeNameMapProvider}");
		}
	
	    resolveDataBinding(TASKTYPENAMEMAPPROVIDER_PROPERTY_BINDINGS, taskTypeNameMapProvider, null, false, true);
		return taskTypeNameMapProvider;
	}
	
	
	/*
	 * TaskContentProvider with binding to a list control exposing 'row' 
	 */
	public com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended getTaskContentProviderExtended()  {
		if (taskContentProviderExtended == null) {
		    taskContentProviderExtended = (com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended)resolveExpression("#{TaskContentProviderExtended}");
		}
	
	    resolveDataBinding(TASKCONTENTPROVIDEREXTENDED_PROPERTY_BINDINGS, taskContentProviderExtended, "taskContentProviderExtended", false, false);
		return taskContentProviderExtended;
	}


	/*
	 * TaskContentProvider with binding to a list control exposing 'selectedTaskRow' 
	 */
	public com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended getTaskContentProviderExtendedForList()  {
		if (taskContentProviderExtended == null) {
		    taskContentProviderExtended = (com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended)resolveExpression("#{TaskContentProviderExtended}");
		}
	
		resolveDataBinding(TASKCONTENTPROVIDEREXTENDEDFORLIST_PROPERTY_BINDINGS, taskContentProviderExtended, "taskContentProviderExtended", true, false);
		return taskContentProviderExtended;
	}

	/**
	 * Getter method for the control with id='searchResultsTableControl'
	 */
	public com.webmethods.caf.faces.component.table.html.DataTable getSearchResultsTableControl() {
		return (com.webmethods.caf.faces.component.table.html.DataTable) findComponentInRoot("searchResultsTableControl");
	}

	public void doDelegateCancel() {
	}
	
	protected String getDelegatePrincipalID() {
		String principalUID = null;
		if( m_delegatePrincipal != null ) {
			return m_delegatePrincipal.getPrincipalID();
		}
		return principalUID;
	}

	public void doDelegateSelectedTasks() {
		String currentUserID = TaskProviderUtils.getCurrentUserID();
		String delegateToID = getDelegatePrincipalID(); 

		List<String> selectedTaskIDs = getSelectedTaskIDs();
		TaskProviderUtils.delegateTasks(selectedTaskIDs, currentUserID, delegateToID);
		getTaskSearchProvider().refresh();
	
	}
	
	/*
	 * Build a list of selected taskIDs
     */
	@SuppressWarnings("unchecked")
	public List<String> getSelectedTaskIDs() {
		Collection coll = getTaskSearchProvider().getRowSelectedIds();
		return new ArrayList<String>(coll);
	}
	
    /*
	 * Get the task content provider
     */
    protected TaskContentProviderExtended getTaskContentProvider( String taskID ) {
    	if( m_taskContentProvider == null ) {
    		m_taskContentProvider = new TaskContentProviderExtended();
        	m_taskContentProvider.setAutoAccept(false);
        	m_taskContentProvider.setNeedAcceptToUpdate(false);
    	}
    	m_taskContentProvider.setTaskID( taskID );
    	return m_taskContentProvider;
    }

	public String getPortletResource( String key ) {
	    return (String)getActivePreferencesBean().getPortletResourcesProvider().getValue( key );
	}

	/*
	 * Build a list of selected ITasksInfo
     */
	public List getSelectedTaskInfos() {

		List<ITaskInfo> selectedTasks = new ArrayList<ITaskInfo>(0x10);
		Collection coll = getTaskSearchProvider().getRowSelectedIds();
		if (coll != null) {
			Iterator taskIter = coll.iterator();
			try {
				while (taskIter != null && taskIter.hasNext()) {
					String rowID = (String) taskIter.next();
					TaskContentProviderExtended tp = getTaskContentProvider(rowID);
					selectedTasks.add(tp.getTaskInfo());
				}
			} catch (Exception ex) {
				String s = getPortletResource( "getselectedids.error");
				ContextUtils.error( s, ex );
			}
				
		}
		return selectedTasks;
	}


	public com.webmethods.caf.faces.data.object.ListTableContentProvider getSelectedTaskInfosProvider()  {
		if (selectedTaskInfosProvider == null) {
		    selectedTaskInfosProvider = (com.webmethods.caf.faces.data.object.ListTableContentProvider)resolveExpression("#{SelectedTaskInfosProvider}");
		}
	
	    resolveDataBinding(SELECTEDTASKINFOSPROVIDER_PROPERTY_BINDINGS, selectedTaskInfosProvider, "selectedTaskInfosProvider", false, false);
		return selectedTaskInfosProvider;
	}

	/**
	 * Action Event Handler for the control with id='commandDelegate'
	 */
	public String commandDelegate_action() {
	    doDelegateSelectedTasks();
	    return null;
	}
	
	public PrincipalModel getDelegatePrincipal() {
		return m_delegatePrincipal;
	}
	
	public void setDelegatePrincipal( PrincipalModel newVal ) {
		m_delegatePrincipal = newVal;
	}
	
	public List getDelegatePrincipalDisplayList() {
		// can currently only select one principal
		List<SelectItem> displayNameList = new ArrayList<SelectItem>();
		PrincipalModel principalModel = getDelegatePrincipal();
		if( principalModel != null ) {
			String principalUID = principalModel.getPrincipalID();
			displayNameList.add( new SelectItem(principalUID, principalUID) );
		}
		return displayNameList;
	}
	
	public void setDelegatePrincipalDisplayList( List newVal ) {
		// do nothing
	}
	
	public TaskDisplayProvider getTaskDisplayProviderForDialog()  {
		if (taskDisplayProviderForDialog == null) {
		    taskDisplayProviderForDialog = (TaskDisplayProvider)resolveExpression("#{TaskDisplayProviderForDialog}");
		}
	
	    resolveDataBinding(TASKDISPLAYPROVIDERFORDIALOG_PROPERTY_BINDINGS, taskDisplayProviderForDialog, "taskDisplayProviderForDialog", true, false);
		return taskDisplayProviderForDialog;
	}
	
	/*
	 * Copy the confirmation list of selected tasks to the bottom of
	 * the principal picker dialog, as well as add action listeners to the 'applyButton' of the picker
	 * (non-Javadoc)
	 * @see com.webmethods.caf.faces.bean.search.BaseSearchResultPageBean#beforeRenderResponse()
	 */
	@SuppressWarnings("unchecked")
	protected void beforeRenderResponse() {
		super.beforeRenderResponse();
		// reset the display providers so they reload fresh task info 
		// if we ask for task info that the provider is alreayd aligned on
		getTaskDisplayProvider().reset();
		getTaskDisplayProviderForDialog().reset();
	}

	/**
	 * Action Event Handler for the control with id='commandUndelegate'
	 */
	public String commandUndelegate_action() {
		String currentUserID = TaskProviderUtils.getCurrentUserID();
		List<String> selectedTaskIDs = getSelectedTaskIDs();
		TaskProviderUtils.undelegateTasks(selectedTaskIDs, currentUserID);
		getTaskSearchProvider().refresh();

	    return null;
	}


	/**
	 * Action Event Handler for the control with id='buttonManageDelegate'
	 */
	public String buttonManageDelegate_action() {
	    return null;
	}

	/**
	 * Opens task details
	 */
	public void openTask() throws Exception {
		super.openTask();
	}	
	
	/**
	 * Accepts and opens task
	 */
	public void acceptAndOpenTask() throws Exception {
		super.acceptAndOpenTask();
	}


	public com.webmethods.caf.ordercreditinboxresults.OrderCreditInboxResults getOrderCreditInboxResults()  {
		if (orderCreditInboxResults == null) {
		    orderCreditInboxResults = (com.webmethods.caf.ordercreditinboxresults.OrderCreditInboxResults)resolveExpression("#{OrderCreditInboxResults}");
		}
		return orderCreditInboxResults;
	}


	public com.webmethods.caf.ordercreditinboxresults.OrderCreditSearchProvider getTaskSearchProvider()  {
		if (taskSearchProvider == null) {
		    taskSearchProvider = (com.webmethods.caf.ordercreditinboxresults.OrderCreditSearchProvider)resolveExpression("#{OrderCreditSearchProvider}");
		}
	
	    resolveDataBinding(TASKSEARCHPROVIDER_PROPERTY_BINDINGS, taskSearchProvider, "taskSearchProvider", false, false);
		return taskSearchProvider;
	}


	/**
	 * Getter method for the control with id='searchResultsForm:delegatePrincipalPicker'
	 */
	public com.webmethods.caf.faces.component.dir.PrincipalPickerModalDialog getDelegatePrincipalPicker_1()  {
		return (com.webmethods.caf.faces.component.dir.PrincipalPickerModalDialog)findComponentInRoot("searchResultsForm:delegatePrincipalPicker");
	}	
}	