package com.webmethods.caf.ordercreditinboxresults;


/**
 * Task Search bean for 'Order Credit' task.
 */
public class OrderCreditSearchProvider extends com.webmethods.caf.faces.data.task.impl.TaskInboxSearchContentProvider {

	private static final long serialVersionUID = 5680330391249152000L;
	private static final String TASK_TYPE_ID = "northwind_task.ordercredit";

	public OrderCreditSearchProvider() {
		super(TASK_TYPE_ID); // task type id to search
		m_searchQuery = new CustomInboxSearchQuery(); 
		getSearchQuery().getTaskTypeID().setValue(TASK_TYPE_ID);
	}

	/**
	 * Typed ITaskData getter
	 * @return current task data
	 */
	public com.webmethods.caf.taskclient.OrderCredit.TaskData getTaskData() {
		return (com.webmethods.caf.taskclient.OrderCredit.TaskData)getValue(PROPERTY_TASKDATA);
	}

	/**
	 * Typed custom search query
	 */
	public CustomInboxSearchQuery getSearchQuery() {  
		return (CustomInboxSearchQuery)m_searchQuery;
	}

	/**
	 * Custom inbox search query that can be extended
	 **/
	public class CustomInboxSearchQuery extends com.webmethods.caf.faces.data.task.impl.TaskInboxSearchContentProvider.InboxSearchQuery {
		private static final long serialVersionUID = 6936110510007089152L;
		private com.webmethods.caf.faces.data.task.impl.TaskSearchQueryTerm orderID = null;
		
		public CustomInboxSearchQuery() {
			super();
		}

		public com.webmethods.caf.faces.data.task.impl.TaskSearchQueryTerm getOrderID()  {
			if (orderID == null) {
				orderID = new com.webmethods.caf.faces.data.task.impl.TaskSearchQueryTerm();
			}
			return orderID;
		}

	}				

}
