/**
 * 
 */
package com.webmethods.caf.ordercreditview;

/**
 * @author oleksiyo
 *
 */

import com.webmethods.caf.faces.data.dir.PrincipalModel;
import com.webmethods.caf.faces.data.dir.PrincipalModelList;
import com.webmethods.caf.faces.data.task.impl.TaskContentProvider;

import java.util.ArrayList;
import java.util.List;

public class OrderCreditViewDefaultviewView extends com.webmethods.caf.faces.bean.BasePageBean {


	
	
	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	private com.webmethods.caf.faces.data.task.TaskDisplayProvider taskDisplayProvider = null;
	private static final String[][] TASKDISPLAYPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskDisplayProvider.taskID}", "#{activePreferencesBean.taskID}"},
	};

	public com.webmethods.caf.faces.data.task.TaskDisplayProvider getTaskDisplayProvider()  {
		if (taskDisplayProvider == null) {
		    taskDisplayProvider = (com.webmethods.caf.faces.data.task.TaskDisplayProvider)resolveExpression("#{TaskDisplayProvider}");
		}
	    resolveDataBinding(TASKDISPLAYPROVIDER_PROPERTY_BINDINGS, taskDisplayProvider, "taskDisplayProvider", false, false);
		return taskDisplayProvider;
	}

	/**
	 * Cancel button action handler
	 */
	public String cancelView() {
		try {
			// just redirect to return (finish) url
			String url = getOrderCreditView().getFinishUrl();
			if (url != null && url.length() > 0) {
				getFacesContext().getExternalContext().redirect(url);
			}
			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}
	
	/**
	 * Complete button action handler
	 */
	public String completeTask() {
		try {
			// do the work
			getOrderCredit().completeTask();
		
			// then redirect to finish url
			String url = getOrderCreditView().getFinishUrl(); 
			if (url != null && url.length() > 0) {
				getFacesContext().getExternalContext().redirect(url);
			}

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}	

	

	/**
	 * Submit button action handler
	 */
	public String submitTask() {
		try {
			
		
			// do the work
			getOrderCredit().applyChanges();
			

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}

	private PrincipalModelList selectedPrincipalList;
	private com.webmethods.caf.ordercreditview.OrderCreditView orderCreditView = null;
	private com.webmethods.caf.taskclient.OrderCredit orderCredit = null;
	private static final String[][] ORDERCREDIT_PROPERTY_BINDINGS = new String[][] {
		{"#{orderCredit.taskID}", "#{OrderCreditView.taskID}"},
		{"#{orderCredit.autoAccept}", "false"},
		{"#{orderCredit.adhocRouting}", "false"},
		{"#{orderCredit.needAcceptToUpdate}", "false"},
	};
	private com.webmethods.caf.is.wsclient.caf.northwind.getorderinfo.GetOrderInfo2 getOrderInfo2 = null;
	private static final String[][] GETORDERINFO2_PROPERTY_BINDINGS = new String[][] {
		{"#{getOrderInfo2.autoRefresh}", "true"},
		{"#{getOrderInfo2.authCredentials.userName}", "Administrator"},
		{"#{getOrderInfo2.authCredentials.password}", "manage"},
		{"#{getOrderInfo2.parameters.orderID}", "#{OrderCreditViewDefaultviewView.orderCredit.taskData.orderID}"},
	};
	private com.webmethods.caf.is.wsclient.caf.northwind.getcustomerinfo.GetCustomerInfo getCustomerInfo = null;
	private static final String[][] GETCUSTOMERINFO_PROPERTY_BINDINGS = new String[][] {
		{"#{getCustomerInfo.autoRefresh}", "true"},
		{"#{getCustomerInfo.authCredentials.userName}", "Administrator"},
		{"#{getCustomerInfo.authCredentials.password}", "manage"},
		{"#{getCustomerInfo.parameters.customerID}", "#{OrderCreditViewDefaultviewView.getOrderInfo2.result.customerID}"},
	};
	private com.webmethods.caf.is.wsclient.caf.northwind.getorderproducts.GetOrderProducts getOrderProducts = null;
	private static final String[][] GETORDERPRODUCTS_PROPERTY_BINDINGS = new String[][] {
		{"#{getOrderProducts.autoRefresh}", "true"},
		{"#{getOrderProducts.authCredentials.userName}", "Administrator"},
		{"#{getOrderProducts.authCredentials.password}", "manage"},
		{"#{getOrderProducts.parameters.orderID}", "#{OrderCreditViewDefaultviewView.orderCredit.taskData.orderID}"},
	};
	private static final String[][] APPROVECREDIT_PROPERTY_BINDINGS = new String[][] {
		{"#{OrderCreditViewDefaultviewView.orderCredit.taskData.approveStatus}", "approved"},
		{"#{OrderCreditViewDefaultviewView.orderCredit.completeTask}", null},
	};
	private static final String[][] REJECTCREDIT_PROPERTY_BINDINGS = new String[][] {
		{"#{OrderCreditViewDefaultviewView.orderCredit.taskData.approveStatus}", "rejected"},
		{"#{OrderCreditViewDefaultviewView.orderCredit.completeTask}", null},
	};
	public PrincipalModelList getPrincipalList() {
		return selectedPrincipalList;
	}
	
	public void setPrincipalList(PrincipalModelList value) {
		this.selectedPrincipalList = value;
	}
	
	/**
	 * Action Event Handler for the control with id='dialogPrincipalAssignTo'
	 */
	public String assignToPrincipals() {
		try {

			// get the current assigned principals for this task
			TaskContentProvider tp = getOrderCredit();

			List<String> currentPrincipalList = new ArrayList<String>();
			String[] currentPrincipalIDs = tp.getTaskInfo().getAssignedToList();
			if (currentPrincipalIDs != null && currentPrincipalIDs.length > 0) {
				for (int ix = 0; ix < currentPrincipalIDs.length; ix++) {
					String principalID = currentPrincipalIDs[ix];
					currentPrincipalList.add( principalID );
				}
			}
			
			// get the selected principals from the picker
			if (selectedPrincipalList != null && selectedPrincipalList.size() > 0) {
				// loop and add the selected principals to the existing list
				for (int ix = 0; ix < selectedPrincipalList.size(); ix++) {
					PrincipalModel principalModel = (PrincipalModel) selectedPrincipalList.get(ix);
					String principalID = principalModel.getPrincipalID(); 
					if( !currentPrincipalList.contains( principalID)) {
						currentPrincipalList.add( principalID );
					}
				}
			}
				
			currentPrincipalIDs = currentPrincipalList.toArray( currentPrincipalIDs);
			tp.getTaskInfo().setAssignedToList(currentPrincipalIDs);
			tp.applyChangesNoAccept();
				
			// then redirect to finish url
			//String url = getRonTask36TaskView().getFinishUrl(); 
			//if (url != null && url.length() > 0) {
			//	getFacesContext().getExternalContext().redirect(url);
			//}				
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR;
		}		
		return OUTCOME_OK;
	}

	public com.webmethods.caf.ordercreditview.OrderCreditView getOrderCreditView()  {
		if (orderCreditView == null) {
		    orderCreditView = (com.webmethods.caf.ordercreditview.OrderCreditView)resolveExpression("#{OrderCreditView}");
		}
		return orderCreditView;
	}

	public com.webmethods.caf.taskclient.OrderCredit getOrderCredit()  {
		if (orderCredit == null) {
		    orderCredit = (com.webmethods.caf.taskclient.OrderCredit)resolveExpression("#{OrderCredit}");
		}
	
	    resolveDataBinding(ORDERCREDIT_PROPERTY_BINDINGS, orderCredit, "orderCredit", false, false);
		return orderCredit;
	}

	public com.webmethods.caf.is.wsclient.caf.northwind.getorderinfo.GetOrderInfo2 getGetOrderInfo2()  {
		if (getOrderInfo2 == null) {
		    getOrderInfo2 = (com.webmethods.caf.is.wsclient.caf.northwind.getorderinfo.GetOrderInfo2)resolveExpression("#{GetOrderInfo2}");
		}
	
	    resolveDataBinding(GETORDERINFO2_PROPERTY_BINDINGS, getOrderInfo2, "getOrderInfo2", false, false);
		return getOrderInfo2;
	}

	public com.webmethods.caf.is.wsclient.caf.northwind.getcustomerinfo.GetCustomerInfo getGetCustomerInfo()  {
		if (getCustomerInfo == null) {
		    getCustomerInfo = (com.webmethods.caf.is.wsclient.caf.northwind.getcustomerinfo.GetCustomerInfo)resolveExpression("#{GetCustomerInfo}");
		}
	
	    resolveDataBinding(GETCUSTOMERINFO_PROPERTY_BINDINGS, getCustomerInfo, "getCustomerInfo", false, false);
		return getCustomerInfo;
	}

	public com.webmethods.caf.is.wsclient.caf.northwind.getorderproducts.GetOrderProducts getGetOrderProducts()  {
		if (getOrderProducts == null) {
		    getOrderProducts = (com.webmethods.caf.is.wsclient.caf.northwind.getorderproducts.GetOrderProducts)resolveExpression("#{GetOrderProducts}");
		}
	
	    resolveDataBinding(GETORDERPRODUCTS_PROPERTY_BINDINGS, getOrderProducts, "getOrderProducts", false, false);
		return getOrderProducts;
	}

	public String approveCredit() {
	    resolveDataBinding(APPROVECREDIT_PROPERTY_BINDINGS, this, "approveCredit.this", true, false);
		return OUTCOME_OK;
	}

	public String rejectCredit() {
	    resolveDataBinding(REJECTCREDIT_PROPERTY_BINDINGS, this, "rejectCredit.this", true, false);
		return OUTCOME_OK;
	}
	
	
}