package com.webmethods.caf.taskclient;


import com.webmethods.caf.faces.data.task.ITaskData;
import com.webmethods.caf.faces.data.ContentProviderException;

/**
 * Task Client bean for 'Order Credit' task.
 */
public class OrderCredit extends com.webmethods.caf.faces.data.task.impl.TaskContentProvider {

	private static final long serialVersionUID = 6931211368242554880L;
	
	/**
	 * Globally unique task type id
	 */
	private static final String TASK_TYPE_ID = "northwind_task.ordercredit";

	/**
	 * Default constructor
	 */
	public OrderCredit() {
		super();
		setTaskTypeID(TASK_TYPE_ID);
	}
	
	/**
	 * Task Data Object
	 */
	public static class TaskData extends com.webmethods.caf.faces.data.task.impl.TaskData {

		private static final long serialVersionUID = 261576045543220224L;
		
		private java.lang.Float creditAmount;

		private java.lang.String approveStatus;

		private java.lang.String orderID;

		public static final String[] INPUTS = new String[] {"creditAmount", "approveStatus", "orderID", };

		public static final String[] OUTPUTS = new String[] {"creditAmount", "approveStatus", "orderID", };

		public TaskData() {
		}

		public java.lang.Float getCreditAmount()  {
			
			return creditAmount;
		}

		public void setCreditAmount(java.lang.Float creditAmount)  {
			this.creditAmount = creditAmount;
		}

		public java.lang.String getApproveStatus()  {
			
			return approveStatus;
		}

		public void setApproveStatus(java.lang.String approveStatus)  {
			this.approveStatus = approveStatus;
		}

		public java.lang.String getOrderID()  {
			
			return orderID;
		}

		public void setOrderID(java.lang.String orderID)  {
			this.orderID = orderID;
		}
		
	}
	
	/**
	 * Return current task data object
	 * @return current task data
	 */
	public TaskData getTaskData() {
		return (TaskData)getValue(PROPERTY_KEY_TASKDATA);
	}

	/**
	 * Creates new task data object
	 * @return newly created task data object
	 */	
	protected ITaskData newTaskData() throws ContentProviderException {
		return new TaskData();
	}

}