/**
 * 
 */
package com.webmethods.caf.analyzabletaskview;

/**
 * @author ronw
 *
 */

import com.webmethods.caf.data.SampleData;
import com.webmethods.caf.faces.data.dir.PrincipalModel;
import com.webmethods.caf.faces.data.dir.PrincipalModelList;
import com.webmethods.caf.faces.data.task.impl.TaskContentProvider;

import java.util.ArrayList;
import java.util.List;

public class AnalyzableTaskViewDefaultviewView extends com.webmethods.caf.faces.bean.task.BaseTaskDetailsPageBean {

 
	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	private com.webmethods.caf.faces.data.task.TaskDisplayProvider taskDisplayProvider = null;
	private static final String[][] TASKDISPLAYPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{TaskDisplayProvider.taskID}", "#{activePreferencesBean.taskID}"},
	};

	public com.webmethods.caf.faces.data.task.TaskDisplayProvider getTaskDisplayProvider()  {
		if (taskDisplayProvider == null) {
		    taskDisplayProvider = (com.webmethods.caf.faces.data.task.TaskDisplayProvider)resolveExpression("#{TaskDisplayProvider}");
		}
	    resolveDataBinding(TASKDISPLAYPROVIDER_PROPERTY_BINDINGS, taskDisplayProvider, "taskDisplayProvider", false, false);
		return taskDisplayProvider;
	}

	/**
	 * Cancel button action handler
	 */
	public String cancelView() {
		try {
			// just redirect to return (finish) url
			String url = getAnalyzableTaskView().getFinishUrl();
			if (url != null && url.length() > 0) {
				getFacesContext().getExternalContext().redirect(url);
			}
			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}
	
	/**
	 * Complete button action handler
	 */
	public String completeTask() {
		try {
			if( !getAnalyzableTask().isUpdateable() ){
				String errMsg = "You must accept a task before updating it";
				error(errMsg);
				return OUTCOME_ERROR; 
			}

			// do the work
			getAnalyzableTask().completeTask(); 
		
			// then redirect to finish url
			String url = getAnalyzableTaskView().getFinishUrl(); 
			if (url != null && url.length() > 0) {
				getFacesContext().getExternalContext().redirect(url);
			}

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}	

	/**
	 * Submit button action handler
	 */
	public String submitTask() {
		try {
			if( !getAnalyzableTask().isUpdateable() ){
				String errMsg = "You must accept a task before updating it";
				error(errMsg);
				return OUTCOME_ERROR; 
			}


			// do the work
			getAnalyzableTask().applyChanges();

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}
	}

	private PrincipalModelList selectedPrincipalList;

	public PrincipalModelList getPrincipalList() {
		return selectedPrincipalList;
	}
	
	public void setPrincipalList(PrincipalModelList value) {
		this.selectedPrincipalList = value;
	}
	
	/**
	 * Action Event Handler for the control with id='dialogPrincipalAssignTo'
	 */
	public String assignToPrincipals() {
		try {

			// get the current assigned principals for this task
			TaskContentProvider tp = getAnalyzableTask();

			List<String> currentPrincipalList = new ArrayList<String>();
			String[] currentPrincipalIDs = tp.getTaskInfo().getAssignedToList();
			if (currentPrincipalIDs != null && currentPrincipalIDs.length > 0) {
				for (int ix = 0; ix < currentPrincipalIDs.length; ix++) {
					String principalID = currentPrincipalIDs[ix];
					currentPrincipalList.add( principalID );
				}
			}
			
			// get the selected principals from the picker
			if (selectedPrincipalList != null && selectedPrincipalList.size() > 0) {
				// loop and add the selected principals to the existing list
				for (int ix = 0; ix < selectedPrincipalList.size(); ix++) {
					PrincipalModel principalModel = (PrincipalModel) selectedPrincipalList.get(ix);
					String principalID = principalModel.getPrincipalID(); 
					if( !currentPrincipalList.contains( principalID)) {
						currentPrincipalList.add( principalID );
					}
				}
			}
				
			currentPrincipalIDs = currentPrincipalList.toArray( currentPrincipalIDs);
			tp.getTaskInfo().setAssignedToList(currentPrincipalIDs);
			tp.applyChangesNoAccept();
				
			// then redirect to finish url
			//String url = getRonTask36TaskView().getFinishUrl(); 
			//if (url != null && url.length() > 0) {
			//	getFacesContext().getExternalContext().redirect(url);
			//}				
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR;
		}		
		return OUTCOME_OK;
	}
	
	private static final String[][] INITIALIZE_PROPERTY_BINDINGS = new String[][] {
		{"#{AnalyzableTask.reset}", null}
	};
	private com.webmethods.caf.analyzabletaskview.AnalyzableTaskView analyzableTaskView = null;
	private com.webmethods.caf.taskclient.AnalyzableTask analyzableTask = null;
	private static final String[][] ANALYZABLETASK_PROPERTY_BINDINGS = new String[][] {
		{"#{AnalyzableTask.taskID}", "#{AnalyzableTaskView.taskID}"},
		{"#{AnalyzableTask.autoAccept}", "false"},
		{"#{AnalyzableTask.adhocRouting}", "false"},
	};
	private com.webmethods.caf.faces.data.object.BoundPropertiesSelectItemGroupProvider customerOptionsProvider = null;
	private static final String[][] CUSTOMEROPTIONSPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{CustomerOptionsProvider.rowVariable}", "customer"},
		{"#{CustomerOptionsProvider.valueBinding}", "#{customer.customerID}"},
		{"#{CustomerOptionsProvider.labelBinding}", "#{customer.companyName}"},
		{"#{CustomerOptionsProvider.list}", "#{AnalyzableTaskViewDefaultviewView.customers}"},
	};

	/**
	 * Initialize page
	 */
	public String initialize() {
		try {
		    resolveDataBinding(INITIALIZE_PROPERTY_BINDINGS, null, "initialize", true, false);

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}	
	}
	
	@Override
	protected void beforeRenderResponse() {
		super.beforeRenderResponse();
	}

	public com.webmethods.caf.analyzabletaskview.AnalyzableTaskView getAnalyzableTaskView()  {
		if (analyzableTaskView == null) {
		    analyzableTaskView = (com.webmethods.caf.analyzabletaskview.AnalyzableTaskView)resolveExpression("#{AnalyzableTaskView}");
		}
		return analyzableTaskView;
	}

	public com.webmethods.caf.taskclient.AnalyzableTask getAnalyzableTask()  {
		if (analyzableTask == null) {
		    analyzableTask = (com.webmethods.caf.taskclient.AnalyzableTask)resolveExpression("#{AnalyzableTask}");
		}
	
	    resolveDataBinding(ANALYZABLETASK_PROPERTY_BINDINGS, analyzableTask, "analyzableTask", false, false);
		return analyzableTask;
	}

	public List<SampleData.CustomerInfo> getCustomers() {
		return SampleData.getInstance().getCustomers();
	}

	public com.webmethods.caf.faces.data.object.BoundPropertiesSelectItemGroupProvider getCustomerOptionsProvider()  {
		if (customerOptionsProvider == null) {
		    customerOptionsProvider = (com.webmethods.caf.faces.data.object.BoundPropertiesSelectItemGroupProvider)resolveExpression("#{CustomerOptionsProvider}");
		}
	
	    resolveDataBinding(CUSTOMEROPTIONSPROVIDER_PROPERTY_BINDINGS, customerOptionsProvider, "customerOptionsProvider", false, false);
		return customerOptionsProvider;
	}
	
	
}