package com.webmethods.caf.data;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class SampleData {
	
	protected Map<String,CustomerInfo> customerMap = null; 	// map of customerID to customer record
	protected Map<String,List<CustomerOrder>> customerOrderMap = null;  // map of customerID to list of CustomerOrders
	protected Map<String,ProductDetail> productMap = null; // map of productID to productDetail
	
	protected static SampleData instance = null;
	
	public static SampleData getInstance() {
		if( instance == null ) {
			instance = new SampleData();
		}
		return instance;
	}
	
	public List<CustomerInfo> getCustomers() {
		return new ArrayList<CustomerInfo>(getCustomerMap().values());
	}
	
	public CustomerInfo getCustomer( String customerID ) {
		return getCustomerMap().get( customerID );
	}
	
	public List<CustomerOrder> getCustomerOrders( String customerID ) {
		return getCustomerOrderMap().get( customerID );
	}
	
	public ProductDetail getProductDetail( String productID ) {
		return getProductMap().get( productID );
	}

	
	protected Map<String,CustomerInfo> getCustomerMap() {
		if( customerMap == null ) {
			customerMap = new TreeMap<String, CustomerInfo>();
			// build up the customer map
			CustomerInfo customer1 = new CustomerInfo();
			customer1.setCustomerID( "QUICK");
			customer1.setCompanyName( "QUICK-Stop");
			customer1.setContactName( "Horst Kloss" );
			customerMap.put( "QUICK", customer1);
			
			CustomerInfo customer2 = new CustomerInfo();
			customer2.setCustomerID( "HUNGC");
			customer2.setCompanyName( "Hungry Coyote Import Store");
			customer2.setContactName( "Yoshi Latimer" );
			customerMap.put( "HUNGC", customer2);

			CustomerInfo customer3 = new CustomerInfo();
			customer3.setCustomerID( "ANTON");
			customer3.setCompanyName( "Antonio Moreno Taquera");
			customer3.setContactName( "Antonio Moreno" );
			customerMap.put( "ANTON", customer3);

		}
		return customerMap;
	}
	
	protected Map<String,List<CustomerOrder>> getCustomerOrderMap() {
		if( customerOrderMap == null ) {
			customerOrderMap = new TreeMap<String,List<CustomerOrder>>();

			
			// build up the customer order map
			List<CustomerOrder> customer1Orders = new ArrayList<CustomerOrder>();
			
			CustomerOrder cust1order1 = new CustomerOrder();
			cust1order1.setOrderID("9776");
			cust1order1.setProductID("PROD1");
			cust1order1.setUnitCount(11);
			customer1Orders.add( cust1order1 );

			CustomerOrder cust1order2 = new CustomerOrder();
			cust1order2.setOrderID("3967");
			cust1order2.setProductID("PROD2");
			cust1order2.setUnitCount(12);
			customer1Orders.add( cust1order2 );
			
			CustomerOrder cust1order3 = new CustomerOrder();
			cust1order3.setOrderID("8848");
			cust1order3.setProductID("PROD3");
			cust1order3.setUnitCount(13);
			customer1Orders.add( cust1order3 );
			
			customerOrderMap.put( "QUICK", customer1Orders );

			List<CustomerOrder> customer2Orders = new ArrayList<CustomerOrder>();
			
			CustomerOrder cust2order1 = new CustomerOrder();
			cust2order1.setOrderID("2699");
			cust2order1.setProductID("PROD4");
			cust2order1.setUnitCount(21);
			customer2Orders.add( cust2order1 );

			CustomerOrder cust2order2 = new CustomerOrder();
			cust2order2.setOrderID("4390");
			cust2order2.setProductID("PROD5");
			cust2order2.setUnitCount(22);
			customer2Orders.add( cust2order2 );
			
			CustomerOrder cust2order3 = new CustomerOrder();
			cust2order3.setOrderID("1122");
			cust2order3.setProductID("PROD6");
			cust2order3.setUnitCount(23);
			customer2Orders.add( cust2order3 );

			customerOrderMap.put( "HUNGC", customer2Orders );

			List<CustomerOrder> customer3Orders = new ArrayList<CustomerOrder>();
			
			CustomerOrder cust3order1 = new CustomerOrder();
			cust3order1.setOrderID("9822");
			cust3order1.setProductID("PROD7");
			cust3order1.setUnitCount(31);
			customer3Orders.add( cust3order1 );

			CustomerOrder cust3order2 = new CustomerOrder();
			cust3order2.setOrderID("3327");
			cust3order2.setProductID("PROD8");
			cust3order2.setUnitCount(32);
			customer3Orders.add( cust3order2 );
			
			CustomerOrder cust3order3 = new CustomerOrder();
			cust3order3.setOrderID("2733");
			cust3order3.setProductID("PROD9");
			cust3order3.setUnitCount(33);
			customer3Orders.add( cust3order3 );

			customerOrderMap.put( "ANTON", customer3Orders );

		
		}
		return customerOrderMap;
	}

	protected Map<String,ProductDetail> getProductMap() {
		if( productMap == null ) {
			
			productMap = new HashMap<String,ProductDetail>();
			// build up the product map
			ProductDetail detail1 = new ProductDetail();
			detail1.setProductID("PROD1");
			detail1.setProductName("Teatime Chocolate Bisquits");
			detail1.setUnitPrice(21.11);
			productMap.put( "PROD1", detail1 );
			
			ProductDetail detail2 = new ProductDetail();
			detail2.setProductID("PROD2");
			detail2.setProductName("Sasquatch Ale");
			detail2.setUnitPrice(14.00);
			productMap.put( "PROD2", detail2 );

			ProductDetail detail3 = new ProductDetail();
			detail3.setProductID("PROD3");
			detail3.setProductName("Steeleye Stout");
			detail3.setUnitPrice(18.00);
			productMap.put( "PROD3", detail3 );

			ProductDetail detail4 = new ProductDetail();
			detail4.setProductID("PROD4");
			detail4.setProductName("Singaporean Hokkien Fried Mee");
			detail4.setUnitPrice(14.195);
			productMap.put( "PROD4", detail4 );

			ProductDetail detail5 = new ProductDetail();
			detail5.setProductID("PROD5");
			detail5.setProductName("Manjimup Dried Apples");
			detail5.setUnitPrice(53.50);
			productMap.put( "PROD5", detail5 );

			ProductDetail detail6 = new ProductDetail();
			detail6.setProductID("PROD6");
			detail6.setProductName("Mozzarella di Giovanni");
			detail6.setUnitPrice(21.11);
			productMap.put( "PROD6", detail6 );

			ProductDetail detail7 = new ProductDetail();
			detail7.setProductID("PROD7");
			detail7.setProductName("Queso Cabrales");
			detail7.setUnitPrice(21.00);
			productMap.put( "PROD7", detail7 );

			ProductDetail detail8 = new ProductDetail();
			detail8.setProductID("PROD8");
			detail8.setProductName("Queso Manchego La Pastora");
			detail8.setUnitPrice(38.00);
			productMap.put( "PROD8", detail8 );

			ProductDetail detail9 = new ProductDetail();
			detail9.setProductID("PROD9");
			detail9.setProductName("Chef Anton's Gumbo Mix");
			detail9.setUnitPrice(21.35);
			productMap.put( "PROD9", detail9 );

		}
		return productMap;
	}

	public class CustomerInfo {
		
		protected String customerID;
		protected String companyName;
		protected String contactName;
		public String getCustomerID() {
			return customerID;
		}
		public void setCustomerID(String customerID) {
			this.customerID = customerID;
		}
		public String getCompanyName() {
			return companyName;
		}
		public void setCompanyName(String companyName) {
			this.companyName = companyName;
		}
		public String getContactName() {
			return contactName;
		}
		public void setContactName(String contactName) {
			this.contactName = contactName;
		}
	}
	
	public class CustomerOrder {
		protected String orderID;
		protected String productID;
		protected int unitCount;

		public String getOrderID() {
			return orderID;
		}
		public void setOrderID(String orderID) {
			this.orderID = orderID;
		}
		public String getProductID() {
			return productID;
		}
		public void setProductID(String productID) {
			this.productID = productID;
		}
		public int getUnitCount() {
			return unitCount;
		}
		public void setUnitCount(int unitCount) {
			this.unitCount = unitCount;
		}
	}
	
	public class ProductDetail {
		protected String productID;
		protected String productName;
		protected double unitPrice;

		public String getProductID() {
			return productID;
		}
		public void setProductID(String productID) {
			this.productID = productID;
		}
		public String getProductName() {
			return productName;
		}
		public void setProductName(String productName) {
			this.productName = productName;
		}
		public double getUnitPrice() {
			return unitPrice;
		}
		public void setUnitPrice(double unitPrice) {
			this.unitPrice = unitPrice;
		}
	}
}
