package com.webmethods.caf.taskclient;


import com.webmethods.caf.faces.data.task.ITaskData;
import com.webmethods.caf.faces.data.ContentProviderException;

/**
 * Task Client bean for 'AnalyzableTask' task.
 */
public class AnalyzableTask extends com.webmethods.caf.faces.data.task.impl.TaskContentProviderExtended {

	private static final long serialVersionUID = 6536836829816787968L;
	
	/**
	 * Globally unique task type id
	 */
	private static final String TASK_TYPE_ID = "FD49D0B8-5D85-49DF-63AF-A6A5AEA371F6";

	/**
	 * Default constructor
	 */
	public AnalyzableTask() {
		super();
		setTaskTypeID(TASK_TYPE_ID);
	}
	
	/**
	 * Task Data Object
	 */
	public static class TaskData extends com.webmethods.caf.faces.data.task.impl.TaskData {

		private static final long serialVersionUID = 6920082084535881728L;
		
		private java.lang.String customerID;

		public static final String[] INPUTS = new String[] {"customerID", };

		public static final String[] OUTPUTS = new String[] {"customerID", };

		public TaskData() {
		}

		public java.lang.String getCustomerID()  {
			
			return customerID;
		}

		public void setCustomerID(java.lang.String customerID)  {
			this.customerID = customerID;
		}
		
	}
	
	/**
	 * Return current task data object
	 * @return current task data
	 */
	public TaskData getTaskData() {
		return (TaskData)getValue(PROPERTY_KEY_TASKDATA);
	}

	/**
	 * Creates new task data object
	 * @return newly created task data object
	 */	
	protected ITaskData newTaskData() throws ContentProviderException {
		return new TaskData();
	}

}