/**
 * 
 */
package com.webmethods.caf.taskcustomerorders;

import java.util.Collections;
import java.util.List;

import com.webmethods.bpm.noodle.IWorkspace;
import com.webmethods.bpm.noodle.IWorkspaceServiceProvider;
import com.webmethods.bpm.noodle.impl.WorkspaceServiceProviderFactory;
import com.webmethods.caf.common.StringTools;
import com.webmethods.caf.data.SampleData;
import com.webmethods.caf.taskclient.AnalyzableTask;
import com.webmethods.portal.noodle.util.NoodleUtils;
import com.webmethods.portal.service.view.IView;
import com.webmethods.portal.system.IURI;

/**
 * @author ronw
 *
 */

public class TaskCustomerOrdersDefaultviewView  extends   com.webmethods.caf.faces.bean.BasePageBean {

	/**
	 * Determines if a de-serialized file is compatible with this class.
	 *
	 * Maintainers must change this value if and only if the new version
	 * of this class is not compatible with old versions. See Sun docs
	 * for <a href=http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/version.html> 
	 * details. </a>
	 */
	private static final long serialVersionUID = 1L;
	private static final String[][] INITIALIZE_PROPERTY_BINDINGS = new String[][] {
	};
	private com.webmethods.caf.taskcustomerorders.TaskCustomerOrders taskCustomerOrders = null;
	
	private com.webmethods.caf.taskclient.AnalyzableTask analyzableTask = null;
	private static final String[][] ANALYZABLETASK_PROPERTY_BINDINGS = new String[][] {
		{"#{AnalyzableTask.taskID}", "#{TaskCustomerOrdersDefaultviewView.taskURI}"},
	};
	private com.webmethods.caf.faces.data.object.ListTableContentProvider customerOrdersProvider = null;
	private static final String[][] CUSTOMERORDERSPROVIDER_PROPERTY_BINDINGS = new String[][] {
		{"#{customerOrdersProvider.rowType}", "com.webmethods.caf.data.SampleData$CustomerOrder"},
		{"#{customerOrdersProvider.rowVariable}", "customerOrder"},
		{"#{customerOrdersProvider.list}", "#{TaskCustomerOrdersDefaultviewView.customerOrders}"},
		{"#{customerOrdersProvider.canTemplateRow}", "false"},
	};
	/**
	 * Initialize page
	 */
	public String initialize() {
		try {
		    resolveDataBinding(INITIALIZE_PROPERTY_BINDINGS, null, "initialize", true, false);

			return OUTCOME_OK;
		} catch (Exception e) {
			error(e);
			log(e);
			return OUTCOME_ERROR; 
		}	
	}

	public com.webmethods.caf.taskcustomerorders.TaskCustomerOrders getTaskCustomerOrders()  {
		if (taskCustomerOrders == null) {
		    taskCustomerOrders = (com.webmethods.caf.taskcustomerorders.TaskCustomerOrders)resolveExpression("#{TaskCustomerOrders}");
		}
		return taskCustomerOrders;
	}
	
	public com.webmethods.caf.data.SampleData.CustomerInfo getCustomerInfo() {
		SampleData.CustomerInfo custInfo = null;

		// get the customerID from the Task associated with this workspace
		String customerID = getAnalyzableTask().getTaskData().getCustomerID();
		if( customerID != null ) {
			custInfo = SampleData.getInstance().getCustomer(customerID);
		}
		return custInfo;
	}

	public List<com.webmethods.caf.data.SampleData.CustomerOrder> getCustomerOrders() {

		List<SampleData.CustomerOrder> orderList = Collections.emptyList();

		// get the customerID from the Task associated with this workspace
		String customerID = getAnalyzableTask().getTaskData().getCustomerID();
		if( customerID != null ) {
			orderList = SampleData.getInstance().getCustomerOrders(customerID);
		}
		return orderList;

	}
	
	/* 
	 * Get the task managed bean for the task associated with this workspace
	 */
	public AnalyzableTask getAnalyzableTask()  {
		if (analyzableTask == null) {
		    analyzableTask = (com.webmethods.caf.taskclient.AnalyzableTask)resolveExpression("#{AnalyzableTask}");
		}
	
	    resolveDataBinding(ANALYZABLETASK_PROPERTY_BINDINGS, analyzableTask, "analyzableTask", false, false);
		return analyzableTask;
	}
	
	public String getTaskURI() throws Exception {
		String taskURI = null;
		IWorkspace workspace = getParentWorkspace();
		if( workspace != null ) {
			// the 'context' property of the workspace context is the TaskURI associated with this workspace
			taskURI = (String)workspace.getContext().getProperty("context");
		}
		return taskURI;
	}
	
	/*
	 * Get the workspace this portlet has been placed inside
	 */
	public IWorkspace getParentWorkspace() throws Exception {
		// determine our parent workspace URI
		String workspaceID = null;
		String instanceURI = this.getPreferences().getValue("uri", "");
		if(StringTools.notEmpty(instanceURI)) {
			IView view = NoodleUtils.getView(instanceURI);
			if( view != null ) {
				// get the parent URI
				IURI parentURI = (IURI)view.getProperty("parentID");
				if( parentURI != null ) {
					workspaceID =parentURI.toString();
				}
			}
		}

		// lookup the workspace by it's workspaceID
		if( workspaceID != null ) {
			IWorkspaceServiceProvider prov = WorkspaceServiceProviderFactory.getWorkspaceServiceProvider();
			return prov.getWorkspaceByID(workspaceID);
		}
		
		return null;
	}

	public com.webmethods.caf.faces.data.object.ListTableContentProvider getCustomerOrdersProvider()  {
		if (customerOrdersProvider == null) {
		    customerOrdersProvider = (com.webmethods.caf.faces.data.object.ListTableContentProvider)resolveExpression("#{CustomerOrdersProvider}");
		}
	
	    resolveDataBinding(CUSTOMERORDERSPROVIDER_PROPERTY_BINDINGS, customerOrdersProvider, "customerOrdersProvider", false, false);
		return customerOrdersProvider;
	}

}